! Sosa-Padilla and Sturzenegger (JIE 2nd round revision)
! Differences with previous submission code:
! 1) No use of IMSL
! 2) Instead of 2 dim B-Spline interpolation we use 2 dim Cubic-Spline interpolation (more standard)
! 3) *Most important* -- The code now folows the one in BSP (RESTUD R&R)
! 4) This is the version w/ production. 
! 5) Decided that I will *NOT* try to make this a fully flexible version, w/ indicators turning on/off endowment and production. 
! It's too much of a hassle and not that useful in the end (given the recalibration involved in the switch btw endowment and prod.)
! 
! IF indicator market access = 2 ==> BAD, HIGH RISK PREMIUM
MODULE param
  IMPLICIT NONE
  !INCLUDE 'link_fnl_shared.h'
  DOUBLE PRECISION :: beta, sigma,output_cost,rw,b_inf, b_sup, b_inf_short, b_sup_short, y_inf, y_sup, eps_inf, eps_sup, std_eps,&
  rho, mean_y, std_y, pi_number, zero, one, width, prob_excl_end, pi, coupon, delta, gamma, d0, d1, cdf_inf, &
  cdf_sup, phi, escala, r_long, omega, psi, tax_inf, tax_sup, net_inf, net_sup, b_recov,&
  kappa, disut_default, alpha, absortion_t, absortion_nt, mu,  h_bar, z_nt, w_bar,&
  phi_firm, r_default, r_premium, curvature_labor, scale_labor, alpha_dp !This are the new parameters w/ production.

!   PARAMETER (std_eps = 0.0340d+0, rho = 0.66d+0, mean_y = -0.5d+0*std_eps**2,  pi_number = 3.
! 1415926535897932d+0, &

  PARAMETER (std_eps = 0.03d+0, rho = 0.90d+0, mean_y = -0.5d+0*std_eps**2,  pi_number = 3.1415926535897932d+0, &
   one=1d+0, zero = 0d+0,  width = 1.5d+0, cdf_inf = 3.167d-5, cdf_sup = 1d+0 - 3.167d-5, pi = 0.00d+0,  &
   gamma = 0.52d+0, rw = 0.042d+0, escala = 1d+0, kappa = 0.0d+0, &
   alpha = 0.75d+0, absortion_nt = 0d+0,   h_bar= 1d+0, z_nt = 1d+0, scale_labor = 1d+0)

  INTEGER :: b_num_short, b_num_long, y_num, eps_num, quad_num, tax_num, access_num, nout, i_y_global, i_excl_global, cdf_num, &
       i_b_short_global, i_b_long_global, i_default_global, i_b_short_next, i_b_long_next,&
       quad_num_v, quad_num_q, b_num_short_finer, b_num_long_finer, y_num_finer, i_access_global, i_access_initial,&
       num_short_next, y_num_coarse, b_num_long_coarse, b_num_short_coarse, net_num
  PARAMETER (b_num_short = 25, b_num_long = 25, y_num =25, quad_num_v = 50, access_num = 2, eps_num =quad_num_v, quad_num_q = 50,&
       cdf_num =50, b_num_short_finer = 50, b_num_long_finer = 50, y_num_finer =50, num_short_next = 30, tax_num = 10, &
       y_num_coarse =15, b_num_long_coarse = 15, b_num_short_coarse = 15, net_num = 100)

  DOUBLE PRECISION :: b_grid_long(1:b_num_long), b_grid_short(1:b_num_short), g_grid(access_num), y_grid(1:y_num),&
       default_grid(1:2), vector_v_global(y_num), y_initial,  b_short_initial, b_long_initial,&
       b_long_global, b_short_global, q_short_global, cdf_grid(cdf_num), quad_w_v(1:quad_num_v), quad_x_v(1:quad_num_v),&
      quad_w_q(1:quad_num_q), quad_x_q(1:quad_num_q),&
       b_short_global_optimize, b_grid_long_finer(1:b_num_long_finer), b_grid_short_finer(1:b_num_short_finer), &
       y_grid_finer(1:y_num_finer), b_next_short_grid(1:num_short_next), &
       b_grid_long_coarse(1:b_num_long), b_grid_short_coarse(1:b_num_short), y_grid_coarse(1:y_num),&
       indicator_global_search, cons_global, premia_grid(2), tax_opt_global, b_next_short_global, b_next_long_global,&
       tax_grid(tax_num), g_global, net_grid(net_num), net_global, q_global, &
       b_short_next_global, util_global, ev_global, b_global,counter, cons_t_global, cons_nt_global, labor_global, wage_global,&
       output_t_global, output_nt_global, rate_global, loan_global

  DOUBLE PRECISION, DIMENSION(b_num_short, b_num_long, y_num, access_num) :: v_matrix
  INTEGER, DIMENSION(b_num_short, b_num_long, y_num, 2) :: default_decision
  DOUBLE PRECISION, DIMENSION(b_num_short, b_num_long, y_num, access_num,2) :: b_next_matrix
  DOUBLE PRECISION, DIMENSION(b_num_short, b_num_long, y_num, access_num) :: v0_matrix, b0_next_short_matrix, b1_next_short_matrix,&
       q_paid_matrix, b0_next_long_matrix, v1_matrix, q_nodef_matrix, g0_matrix, g1_matrix, tax0_matrix, tax1_matrix
  DOUBLE PRECISION, DIMENSION(2, 2) :: trans_matrix

  DOUBLE PRECISION, DIMENSION(net_num, y_num_finer) :: tax0_interp_matrix, tax1_interp_matrix
  DOUBLE PRECISION, DIMENSION(b_num_short_finer+2, y_num_finer, access_num) :: coeff_matrix_b_limit
  DOUBLE PRECISION, DIMENSION(b_num_short+2, b_num_long+2, y_num, access_num) :: coeff_matrix_v0, coeff_matrix_q !Double check if using last one!!
  DOUBLE PRECISION, DIMENSION(b_num_short_finer+2, b_num_long_finer+2, y_num_finer, access_num) :: coeff_matrix_ev,&
       coeff_matrix_q_menu, coeff_matrix_ev_excl, coeff_matrix_q1_menu, coeff_matrix_def_prob

END MODULE param


!SPECIFY GRID VALUES
SUBROUTINE compute_grid
  USE param
  USE toolbox
  IMPLICIT NONE
  DOUBLE PRECISION :: delta_y, y_left, prob_vector(y_num), y_right
  INTEGER ::  i,j

  coupon = (rw + delta) / (1d+0 + rw)
  std_y = std_eps/ SQRT(1d+0 - rho**2)

  y_inf = mean_y - 5d+0*std_y
  y_sup = mean_y + 5d+0*std_y
  delta_y = 5d+0*std_y / (y_num - 1d+0)

  b_inf = 0.00001d+0 !MIN(0.55d+0*EXP(y_sup), .99*EXP(y_inf))
!   b_sup =  min(1d+0, exp(y_inf)/coupon-0.05d+0)
  b_sup =  0.65d+0
!   b_sup = 1.3d+0

  b_inf_short = 0d+0 
  b_sup_short =  0.30d+0
!   b_sup_short =  0.40d+0
!   b_sup_short =  0.60d+0

  OPEN (10, FILE='b_grid_short.txt',STATUS='replace')
  OPEN (11, FILE='y_grid.txt',STATUS='replace')
  OPEN (12, FILE='b_grid_long.txt',STATUS='replace')
  OPEN (13, FILE='bounds.txt',STATUS='replace')


  WRITE(13, '(F15.11, X, F15.11)') b_inf, b_sup
  WRITE(13, '(F15.11, X, F15.11)') b_inf_short, b_sup_short
  WRITE(13, '(F15.11, X, F15.11)') y_inf, y_sup


  DO i=1,b_num_short
     b_grid_short(i) = b_inf_short + (b_sup_short - b_inf_short)*(i-1d+0)/(b_num_short - 1d+0)
  END DO

  DO i=1,b_num_long
     b_grid_long(i) = b_inf + (b_sup - b_inf)*(i-1d+0)/(b_num_long - 1d+0)
  END DO


  DO i=1,b_num_short
     WRITE(10, '(F12.8, X, F12.8)') b_grid_short(i)
  END DO

  DO i=1,b_num_long
     WRITE(12, '(F12.8, X, F12.8)') b_grid_long(i)
  END DO

  DO i=1,y_num
     y_grid(i) = y_inf + (y_sup - y_inf) * (i-1) / (y_num - 1)
     WRITE(11, '(F12.8)') y_grid(i)
  END DO

  CLOSE(10)
  CLOSE(11)
  CLOSE(12)
  CLOSE(13)


  OPEN (16, FILE='trans_matrix.txt',STATUS='replace')
  DO i=1,access_num
     DO j=1,access_num
        WRITE(16, '(F12.8)') trans_matrix(i,j)
     END DO
  END DO
  CLOSE(16)


  DO i=1,cdf_num
     cdf_grid(i) = cdf_inf + (cdf_sup - cdf_inf) * (i-1) / (cdf_num - 1)
  END DO

  default_grid(1) = 0.0d+0
  default_grid(2) = 1.0d+0

  eps_inf = -4d+0*std_eps
  eps_sup =  4d+0*std_eps

  OPEN (20, FILE='b_short_finer.txt',STATUS='replace')
  OPEN (22, FILE='b_long_finer.txt',STATUS='replace')

  DO i=1,b_num_short_finer
     b_grid_short_finer(i) = b_inf_short + (b_sup_short - b_inf_short)*(i-1d+0)/(b_num_short_finer - 1d+0)
     WRITE(20, '(F12.8)') b_grid_short_finer(i)
  END DO

  DO i=1,b_num_long_finer
     b_grid_long_finer(i) = b_inf + (b_sup - b_inf)*(i-1d+0)/(b_num_long_finer - 1d+0)
     WRITE(22, '(F12.8)') b_grid_long_finer(i)
  END DO

  CLOSE(20)
  CLOSE(22)
  DO i=1,y_num_finer
     y_grid_finer(i) = y_inf + (y_sup - y_inf) * (i-1) / (y_num_finer - 1)
  END DO

  !DEFIINE GRID OF RESERVE WHICH OPTIMIZE USES WHEN SOLVING THE OPTIMUM AT EACH RESERVE POINT
  !IT IS DEFINED HERE SO THAT IT SIMPLIFIES THE FIRST LINES OF CODE IN OPTIMIZE.
  !NEED TO CONSIDER POINTS CLOSE TO THE BOUNDARIES IN ORDER TO AVOID THE CODE TO PICK UP OPTIMAL
  !VALUES AT THE BOUNDARIES WHEN THE OPTIMAL COMBINATION OF RESERVES, DEBT ARE AWAY FROM THE BOUNDARIES
  !FOR RESERVES.
  b_next_short_grid(1) = b_inf_short
  b_next_short_grid(2) = b_inf_short + 0.001d+0
  DO i=2,num_short_next-3
     b_next_short_grid(i+1) = b_inf_short + (b_sup_short - b_inf_short) * (i-1)/ (num_short_next - 3)
  END DO
  b_next_short_grid(num_short_next-1) = b_sup_short-0.001d+0
  b_next_short_grid(num_short_next) = b_sup_short


  OPEN (16, FILE='pdf_y.txt',STATUS='replace')
  !Aproximate unconditional p.d.f. of y
  y_left  = (y_grid(1) + delta_y)/ std_y
  y_right = (y_grid(y_num) - delta_y)/ std_y

  prob_vector(1) = normalCDF(y_left)
  prob_vector(y_num) = 1d+0 - normalCDF(y_right)
!   prob_vector(1)     = DNORDF(y_left)
!   prob_vector(y_num) = 1d+0 - DNORDF(y_right)
  WRITE(16, '(F12.8)') prob_vector(1)
  DO j=2,y_num-1
     y_right = (y_grid(j) + delta_y )/ std_y
     y_left  = (y_grid(j) - delta_y )/ std_y
   !   prob_vector(j) = (DNORDF(y_right) - DNORDF(y_left) ) !/prob_may_num
     prob_vector(j) = (normalCDF(y_right) - normalCDF(y_left) ) !/prob_may_num
     !     WRITE(nout, '(F12.8, X, F12.8, X, F12.8, X, F12.8, X, F12.8)')  y_grid(j), y_left, y_right, prob_vector(j)
     WRITE(16, '(F12.8)') prob_vector(j)
  END DO
  WRITE(16, '(F12.8)') prob_vector(y_num)
  CLOSE (16)

END SUBROUTINE compute_grid


subroutine quadrature
USE param
USE toolbox
implicit none
INTEGER :: N_v, N_q
parameter(N_v = quad_num_v, N_q = quad_num_q)

!quad_w = weights using Gauss legendre quadrature rule
!quad_x = points using Gauss legendre quadrature rule

call legendre(-1d+0, 1d+0, quad_x_v, quad_w_v)
call legendre(-1d+0, 1d+0, quad_x_q, quad_w_q)

! This is what we had before using the toolbox:
! call gauleg(-1d+0, 1d+0, quad_x_v, quad_w_v, N_v)
! call gauleg(-1d+0, 1d+0, quad_x_q, quad_w_q, N_q)

end subroutine

DOUBLE PRECISION FUNCTION u_fun(cons, labor)
  USE param
  IMPLICIT NONE
  DOUBLE PRECISION, INTENT(IN) :: cons, labor
  DOUBLE PRECISION :: arg_cons, arg_labor
  arg_cons = max(cons, 1d-6)
  arg_labor = max(labor, 1d-6)
   u_fun = (arg_cons - scale_labor * (arg_labor**curvature_labor)/curvature_labor)**(1d+0-sigma)/(1d+0-sigma)
END FUNCTION u_fun

DOUBLE PRECISION FUNCTION dif_fun(y)
  USE param
  IMPLICIT NONE
  DOUBLE PRECISION, INTENT(IN) :: y
  DOUBLE PRECISION, EXTERNAL:: v0_fun, v1_fun

  dif_fun = v0_fun(b_short_global, b_long_global,  y, i_access_global) - v1_fun(b_short_global, b_long_global, y, i_access_global)
END FUNCTION dif_fun

!FUNCTION USED TO COMPUTE THE MINIMUM INCOME FOR WHICH THE CURRENT PARTY IN POWER DOES NOT DEFAULT
!b = outstanding debt
DOUBLE PRECISION FUNCTION y_fun(b_short, b_long, index_access)
  USE param
  USE toolbox
  IMPLICIT NONE
  DOUBLE PRECISION, INTENT(IN) :: b_short, b_long
  INTEGER, INTENT(IN) :: index_access
  LOGICAL :: check_return
  DOUBLE PRECISION :: left, right, y_max, y_min, dif_right, dif_left, valor
  DOUBLE PRECISION, EXTERNAL :: dif_fun

  y_max = rho*y_initial + (1d+0-rho)*mean_y + width*eps_sup
  y_min = rho*y_initial + (1d+0-rho)*mean_y + width*eps_inf

  b_short_global = b_short     !b_global IS USED IN dif_fun TO FIX THE VALUE OF b (OUTSTANDING DEBT)
  b_long_global = b_long     !b_global IS USED IN dif_fun TO FIX THE VALUE OF b (OUTSTANDING DEBT)
  i_access_global = index_access

  dif_right = dif_fun(y_max)
  dif_left  = dif_fun(y_min)

  !1) DETERMINE WHETHER THERE IS AN INTERIOR ROOT OR NOT
  !   a) IF THERE IS AN INTERIOR ROOT, SPECIFY WHETHER THE difference function IS INCREASING IN g OR NOT.
  !   b) IF THERE IS NO INTERIOR ROOT, DETERMINE WHETHER THE GOV'T ALWAYS OR NEVER DEFAULTS

  if (dif_right*dif_left<0) then  !THERE IS AN INTERIOR ROOT
   left =  y_min
   right = y_max
   valor = (y_min+y_max)/2d+0
   call fzero(valor, dif_fun,check_return)
   y_fun = valor
   else if (dif_left>0) then
      y_fun = y_min
   else !dif_right<0
      y_fun = y_max
   end if

END FUNCTION y_fun

DOUBLE PRECISION FUNCTION q_fun(b_short_next, b_long_next, y, index_access)
USE param
USE toolbox
IMPLICIT NONE
DOUBLE PRECISION, INTENT(IN) :: b_short_next, b_long_next, y
INTEGER, INTENT(IN) :: index_access
INTEGER :: i, index_access_next
DOUBLE PRECISION :: prob_no_def_tomorrow, y_current_type, y_threshold, exp_q(2), y_next, cdf, cdf_threshold, m_next, exp_m(2)
DOUBLE PRECISION, EXTERNAL:: y_fun, q_paid_fun

exp_m = 0d+0
exp_q = 0d+0

IF (b_long_next<=0d+0) THEN
   q_fun = 100000 !coupon * (1d+0 - ((1d+0 - delta)/EXP(rw))**counter)/ (delta + EXP(rw)-1)
   
   ELSEIF(b_long_next <=b_sup) THEN !SET POSITIVE PRICES ONLY FOR b' THAT ARE ABOVE THE MINIMUM VALUE. (AVOID OPTIMAL VALUES OUTSIDE THE RANGE)
      DO index_access_next = 1,access_num
         y_threshold = y_fun(b_short_next, b_long_next, index_access_next)
         y_current_type = (y_threshold - rho * y - (1-rho)*mean_y) / std_eps
         cdf_threshold = normalCDF(y_current_type)
         
         IF (cdf_threshold <= cdf_inf) THEN !THRESHOLD TOMORROW IS LOW
            prob_no_def_tomorrow = 1d+0
            DO i=1,quad_num_q
               cdf = 0.5*(quad_x_q(i) + 1)*(cdf_sup - cdf_inf) + cdf_inf
               y_next  = (1-rho)*mean_y + rho* y_initial + normalCDF_Inv(cdf) * std_eps
               m_next = EXP(-rw - premia_grid(index_access) * ( y_next - ( (1d+0-rho)*mean_y + rho* y_initial)) - &
               0.5d+0*(premia_grid(index_access)**2d+0)*std_eps**2d+0)
               exp_m(index_access_next) = exp_m(index_access_next) + m_next * coupon * (1d+0 + phi * (EXP(y_next)-1d+0)) * & 
               0.5d+0* (cdf_sup - cdf_inf)*quad_w_q(i)
               exp_q(index_access_next) = exp_q(index_access_next) + (1d+0-delta) * m_next* &
               q_paid_fun(b_short_next, b_long_next, y_next, index_access_next) *0.5d+0*(cdf_sup-cdf_inf)*quad_w_q(i)
            END DO
            ELSEIF (cdf_threshold >= cdf_sup) THEN !THRESHOLD TOMORROW IS HIGH
              exp_q(index_access_next) = 0d+0
            ELSE
            prob_no_def_tomorrow = (1d+0 - cdf_threshold)
            DO i=1,quad_num_q
               !compute integral for y > y_threshold
               cdf = 0.5d+0*(quad_x_q(i) + 1d+0)*(cdf_sup - cdf_threshold) + cdf_threshold
               y_next  = (1d+0-rho)*mean_y + rho* y_initial + normalCDF_Inv(cdf) * std_eps
               m_next = EXP(-rw - premia_grid(index_access) * ( y_next - ( (1d+0-rho)*mean_y + rho* y_initial)) - &
               0.5d+0*(premia_grid(index_access)**2d+0)*std_eps**2d+0)
               exp_m(index_access_next) = exp_m(index_access_next) + m_next*coupon *&
               (1d+0 + phi * (EXP(y_next)-1d+0))* 0.5d+0* (cdf_sup - cdf_threshold)*quad_w_q(i)

               exp_q(index_access_next) = exp_q(index_access_next) + (1d+0 - delta) * m_next * &
               q_paid_fun(b_short_next, b_long_next, y_next, index_access_next)*0.5d+0* (cdf_sup - cdf_threshold)*quad_w_q(i)
            END DO
         END IF
         exp_q(index_access_next) = trans_matrix(index_access, index_access_next) * exp_q(index_access_next) / (cdf_sup - cdf_inf)
         exp_m(index_access_next) = trans_matrix(index_access, index_access_next) * exp_m(index_access_next) / (cdf_sup - cdf_inf)
      END DO
      q_fun = MAX(SUM(exp_m + exp_q), 0d+0)
   ELSE
      q_fun = 0d+0 !This is the case of borrowing beyond the upper bound.
   END IF

END FUNCTION q_fun

DOUBLE PRECISION FUNCTION def_prob_tomorrow_fun(b_short_next, b_long_next, y, index_access)
USE param
USE toolbox
IMPLICIT NONE
DOUBLE PRECISION, INTENT(IN) :: b_short_next, b_long_next, y
INTEGER, INTENT(IN) :: index_access
INTEGER :: index_access_next
DOUBLE PRECISION :: y_current_type, y_threshold, cdf_threshold, exp_m(2)
DOUBLE PRECISION, EXTERNAL:: y_fun

exp_m = 0d+0

IF (b_long_next<=0d+0) THEN
   def_prob_tomorrow_fun = zero !The country is taking on negative debt (assets), it will repay.
   
   ELSEIF(b_long_next <=b_sup) THEN       
      DO index_access_next = 1,access_num
         y_threshold = y_fun(b_short_next, b_long_next, index_access_next)
         y_current_type = (y_threshold - rho * y - (1-rho)*mean_y) / std_eps
         cdf_threshold = normalCDF(y_current_type)
         
         IF (cdf_threshold <= cdf_inf) THEN !THRESHOLD TOMORROW IS LOW
            exp_m(index_access_next) = zero
            

         ELSEIF (cdf_threshold >= cdf_sup) THEN !THRESHOLD TOMORROW IS HIGH
            exp_m(index_access_next) = one
            
         ELSE
            exp_m(index_access_next) = cdf_threshold
            
         END IF

         exp_m(index_access_next) = trans_matrix(index_access, index_access_next) * exp_m(index_access_next) / (cdf_sup - cdf_inf)
      END DO
      def_prob_tomorrow_fun = MIN(MAX(SUM(exp_m), zero),one)
   ELSE
      def_prob_tomorrow_fun = one 
   END IF

END FUNCTION def_prob_tomorrow_fun


! This is the "synthetic" price of a one-period lived bond
DOUBLE PRECISION FUNCTION q1_fun(b_short_next, b_long_next, y, index_access)
USE param
USE toolbox
IMPLICIT NONE
DOUBLE PRECISION, INTENT(IN) :: b_short_next, b_long_next, y
INTEGER, INTENT(IN) :: index_access
INTEGER :: i, index_access_next
DOUBLE PRECISION :: prob_no_def_tomorrow, y_current_type, y_threshold, exp_q(2), y_next, cdf, cdf_threshold, m_next, exp_m(2),&
coupon_local, delta_local
DOUBLE PRECISION, EXTERNAL:: y_fun

delta_local = one
coupon_local = (rw + delta_local) / (one + rw)

exp_m = 0d+0
exp_q = 0d+0

IF (b_long_next<=0d+0) THEN
   q1_fun = 100000 !coupon * (1d+0 - ((1d+0 - delta)/EXP(rw))**counter)/ (delta + EXP(rw)-1)
   
   ELSEIF(b_long_next <=b_sup) THEN !SET POSITIVE PRICES ONLY FOR b' THAT ARE ABOVE THE MINIMUM VALUE. (AVOID OPTIMAL VALUES OUTSIDE THE RANGE)
      DO index_access_next = 1,access_num
         y_threshold = y_fun(b_short_next, b_long_next, index_access_next)
         y_current_type = (y_threshold - rho * y - (1-rho)*mean_y) / std_eps
         cdf_threshold = normalCDF(y_current_type)
         
         IF (cdf_threshold <= cdf_inf) THEN !THRESHOLD TOMORROW IS LOW
            prob_no_def_tomorrow = 1d+0
            DO i=1,quad_num_q
               cdf = 0.5*(quad_x_q(i) + 1)*(cdf_sup - cdf_inf) + cdf_inf
               y_next  = (1-rho)*mean_y + rho* y_initial + normalCDF_Inv(cdf) * std_eps
               m_next = EXP(-rw - premia_grid(index_access) * ( y_next - ( (1d+0-rho)*mean_y + rho* y_initial)) - &
               0.5d+0*(premia_grid(index_access)**2d+0)*std_eps**2d+0)
               exp_m(index_access_next) = exp_m(index_access_next) + m_next * coupon_local * (1d+0 + phi * (EXP(y_next)-1d+0)) * & 
               0.5d+0* (cdf_sup - cdf_inf)*quad_w_q(i)
               ! Decided to comment out the exp_q part. It doesn't play any role.
               ! exp_q(index_access_next) = exp_q(index_access_next) + (1d+0-delta_local) * m_next* &
               ! q_paid_fun(b_short_next, b_long_next, y_next, index_access_next) *0.5d+0*(cdf_sup-cdf_inf)*quad_w_q(i)
            END DO
            ELSEIF (cdf_threshold >= cdf_sup) THEN !THRESHOLD TOMORROW IS HIGH
              exp_q(index_access_next) = 0d+0
            ELSE
            prob_no_def_tomorrow = (1d+0 - cdf_threshold)
            DO i=1,quad_num_q
               !compute integral for y > y_threshold
               cdf = 0.5d+0*(quad_x_q(i) + 1d+0)*(cdf_sup - cdf_threshold) + cdf_threshold
               y_next  = (1d+0-rho)*mean_y + rho* y_initial + normalCDF_Inv(cdf) * std_eps
               m_next = EXP(-rw - premia_grid(index_access) * ( y_next - ( (1d+0-rho)*mean_y + rho* y_initial)) - &
               0.5d+0*(premia_grid(index_access)**2d+0)*std_eps**2d+0)
               exp_m(index_access_next) = exp_m(index_access_next) + m_next*coupon_local *&
               (1d+0 + phi * (EXP(y_next)-1d+0))* 0.5d+0* (cdf_sup - cdf_threshold)*quad_w_q(i)

               ! exp_q(index_access_next) = exp_q(index_access_next) + (1d+0 - delta_local) * m_next * &
               ! ! q_paid_fun(b_short_next, b_long_next, y_next, index_access_next)*0.5d+0* (cdf_sup - cdf_threshold)*quad_w_q(i)
            END DO
         END IF
         exp_q(index_access_next) = trans_matrix(index_access, index_access_next) * exp_q(index_access_next) / (cdf_sup - cdf_inf)
         exp_m(index_access_next) = trans_matrix(index_access, index_access_next) * exp_m(index_access_next) / (cdf_sup - cdf_inf)
      END DO
      q1_fun = MAX(SUM(exp_m + exp_q), 0d+0)
   ELSE
      q1_fun = 0d+0 !This is the case of borrowing beyond the upper bound.
   END IF

END FUNCTION q1_fun

DOUBLE PRECISION FUNCTION objective_function(X)
  USE param
  IMPLICIT NONE
  DOUBLE PRECISION, INTENT (IN) :: X(2)
  DOUBLE PRECISION :: exp_v_next,q, borrowing, output_t, b_short, b_long, q_short, &
  penalty, labor, wage, cons_t, util, b_sup_local, rate, loan, productivity, dp_tomorrow
  DOUBLE PRECISION, EXTERNAL:: EV_fun, q_menu_fun, u_fun, def_prob_tomorrow_interp_fun

   b_short = MAX(MIN(X(1), b_sup_short), b_inf_short)

   b_sup_local = b_sup !NO NEED TO CALCULATE ISSUANCE LIMIT
   b_long  = MAX(MIN(X(2), b_sup_local), b_inf)

   !PENALIZE IF DEBT IS OUTSIDE SPECIFIED RANGE. THIS PENALTY SPEEDS UP OPTIMIZATION ROUTINE. ALTERNATIVE TO    HAVE
   !A FLAT FUNCTION IN THAT REGION MAKES OPTIMIZATION ROUTINE EXAUST ITS MAXIMUM NUMBER OF ITERATIONS
   penalty = 10d+0*(MAX(b_inf-X(2),0d+0)**2d+0 + MAX(X(2)-b_sup_local,0d+0)**2d+0 +&
   MAX(b_inf_short-X(1),0d+0)**2d+0 + MAX(X(1)-b_sup_short,0d+0)**2d+0)

   !CALCULATE EXPECTED CONTINUATION VALUE
   exp_v_next = EV_fun(b_short, b_long, y_initial, i_access_initial)

   q_short = EXP(-rw)
   q = q_menu_fun(b_short, b_long, y_initial, i_access_initial)
   dp_tomorrow = def_prob_tomorrow_interp_fun(b_short, b_long, y_initial, i_access_initial)

   ! yield_1 = min(max(yield_1, zero), 1d+0)

   productivity = escala*EXP(y_initial)
   rate = alpha_dp * dp_tomorrow + r_premium + phi_firm *  (escala - productivity)/escala

   labor = ((alpha * productivity)/(1d+0 + gamma * rate) * one/scale_labor)**(one/(curvature_labor-alpha))
   wage = scale_labor * labor**(curvature_labor-one)

   loan = gamma * wage * labor
   output_t = productivity * labor**(alpha)

   borrowing =  b_long - b_long_initial*(1d+0 - delta)

   cons_t = output_t + b_short_initial - absortion_t - loan * rate - &
         coupon*(1d+0 + phi *(productivity-escala)/escala)* b_long_initial + &
         borrowing * q - b_short * q_short

   ! cons_t = output_t + b_short_initial - absortion_t - loan * rate - &
            ! coupon*(1d+0 + phi *(productivity-one))* b_long_initial + &
            ! borrowing * q - b_short * q_short

   util = u_fun(cons_t, labor)

   objective_function =  - (util + beta*exp_v_next - penalty)

   ! write(*,*) 'util ', util,'penalty ',penalty ,'exp_v_next ', exp_v_next
   ! write(*,*) 'cons ', cons_t, 'labor ', labor

   cons_t_global = cons_t
   labor_global = labor
   wage_global = wage
   output_t_global = output_t
   loan_global = loan
   rate_global = rate


END FUNCTION objective_function


!RHS of BELLMAN EQUATION WHEN EXCLUDED FROM CREDIT MARKETS. NO DEBT IS CHOSEN OR REPAID AND THE ONLY CHOICE IS THE
!RESERVE ACCUMULATION
DOUBLE PRECISION FUNCTION objective_function_excl(reserves)
 USE param
 IMPLICIT NONE
 DOUBLE PRECISION, INTENT(IN) :: reserves
 DOUBLE PRECISION :: output_t, b_short, b_long, q_short, exp_v_next,&
 labor, cons_t, util,  wage, prod_loss, productivity, loan, rate
 DOUBLE PRECISION, EXTERNAL :: EV_excl_fun, u_fun

   b_long = b_long_initial*EXP(rw) !This is like long_debt in arrears growing at the r_w rate.
   b_short = MAX(MIN(reserves, b_sup_short), b_inf_short)

   q_short = EXP(-rw) ! risk_free price for reserves

   prod_loss = max(zero, exp(y_initial)*(d0 + d1*(exp(y_initial) - one)))
   productivity = EXP(y_initial) - prod_loss
   productivity = max(zero, productivity) !Cannot let productivity be zero.
   productivity = escala * productivity

   rate = r_default

   labor = ((alpha * productivity)/(1d+0 + gamma * rate) * one/scale_labor)**(one/(curvature_labor-alpha))
   wage = scale_labor * labor**(curvature_labor-one)
   loan = gamma * wage * labor
   output_t = productivity * labor**(alpha)
   cons_t = output_t + b_short_initial - absortion_t - loan * rate - b_short*q_short
   ! cons_t = max(cons_t,1d-6)
   util = u_fun(cons_t, labor)

   exp_v_next = EV_excl_fun(b_short, b_long, y_initial, i_access_initial) 
   objective_function_excl = - (util + beta * exp_v_next)
!   write(*,*) 'util', util, 'exp_v_next', exp_v_next

   cons_t_global = cons_t   
   labor_global = labor
   loan_global = loan
   wage_global = wage
   output_t_global = output_t
   rate_global = rate   

END FUNCTION objective_function_excl


!RHS of BELLMAN EQUATION FOR A GIVEN RESERVE LEVEL. THIS FUNCTION IS USED TO COMPUTE THE OPTIMAL DEBT LEVEL
!FOR A GIVEN CHOICE OF RESERVES
DOUBLE PRECISION FUNCTION objective_function_debt(debt)
  USE param
  IMPLICIT NONE
  DOUBLE PRECISION, INTENT(IN) :: debt
  DOUBLE PRECISION :: b_short, b_long
  DOUBLE PRECISION, EXTERNAL:: objective_function

  b_short = b_short_global_optimize
  b_long  = MAX(MIN(debt, b_sup), b_inf)

  objective_function_debt = objective_function((/b_short, b_long/))

END FUNCTION objective_function_debt


SUBROUTINE optimize(b_next, v_value)
  USE param
  USE toolbox
  IMPLICIT NONE
  INTEGER :: num_tirar, N, index_short,  i, NP, num_long, ITER
  PARAMETER (num_long=100, num_tirar = 200, N=2, NP = 2)
  DOUBLE PRECISION, INTENT(OUT) :: b_next(2), v_value
  DOUBLE PRECISION :: new_value, old_value,b_next_short, b_next_long, b_next_guess(2),  b_next_inf, b_next_sup, &
  matrix_direction(N,N), FTOL, FVALUE  
  DOUBLE PRECISION, EXTERNAL:: objective_function

  b_next_inf = b_inf
  b_next_sup = b_sup

  IF (indicator_global_search > 0) THEN  !SEARCH FOR BEST INITIAL GUESS USING ALL GRID RANGE
   
   !Below I initialize b_next_guess and index_short. In normal working of the routine, these should be overwritten.
   b_next_guess(1) = b0_next_short_matrix(i_b_short_global, i_b_long_global, i_y_global, i_access_initial)
   b_next_guess(2) = b0_next_long_matrix(i_b_short_global, i_b_long_global, i_y_global, i_access_initial)
   index_short = 7 !SET IT TO A NUMBER > 1 & < num_short_next SO THAT THE OPTIMIZATION ROUTINE IS INVOKED

   old_value = 10d+15
   DO i=1,num_short_next
      b_next_short = b_next_short_grid(i)
      b_short_global_optimize = b_next_short
      !FIND THE OPTIMAL DEBT ACCUMULATION AND IMPLIED CONTINUATION VALUE FOR A CHOICE OF RESERVES = b_next_short
      CALL optimize_debt(b_next_long, new_value)
      ! write(*,*) 'value from optimize debt=', new_value
      IF (new_value <= old_value) THEN
         b_next_guess(1) = b_next_short
         b_next_guess(2) = b_next_long
         old_value = new_value
         index_short = i
      END IF
   END DO

  ELSE !FOCUS GRID SEARCH IN A NEIGHBORHOOD OF PREVIOUS OPTIMAL VALUE

     b_next_guess(1) = b0_next_short_matrix(i_b_short_global, i_b_long_global, i_y_global, i_access_initial)
     b_next_guess(2) = b0_next_long_matrix(i_b_short_global, i_b_long_global, i_y_global, i_access_initial)
     index_short = 2 !SET IT TO A NUMBER > 1 & < num_short_next SO THAT THE OPTIMIZATION ROUTINE IS INVOKED
   END IF

  IF (index_short ==1) THEN
     b_next = b_next_guess
     v_value = -objective_function(b_next)
  ELSEIF(index_short ==num_short_next ) THEN
      ! write(*,*)'option 2', ' index_short', index_short
      ! write(*,*)'option 2', 'bs', b_next_guess(1), 'bl', b_next_guess(2)

     b_next = b_next_guess
     v_value = -objective_function(b_next)
  ELSE
   ! WRITE(*,*) 'CALLING POWELL'
   ! WRITE(*,*) b_next_guess(1), b_next_guess(2), index_short

   matrix_direction = 0d+0
   matrix_direction(1,1) = 1d+0
   matrix_direction(2,2) = 1d+0
   FTOL = 1d-8 
   CALL POWELL(objective_function, b_next_guess, matrix_direction, N, NP, FTOL, ITER, FVALUE)
   b_next(1) = MAX(MIN(b_next_guess(1), b_sup_short), b_inf_short)
   b_next(2)  = MAX(MIN(b_next_guess(2), b_sup), b_inf)
   ! v_value = -FVALUE
   v_value = -objective_function(b_next)

  END IF

  
END SUBROUTINE optimize


SUBROUTINE optimize_excl(b_next, v_value)
  USE param
  USE toolbox
  IMPLICIT NONE
  INTEGER :: index_opt, num, i
  PARAMETER (num=20)
  DOUBLE PRECISION, INTENT(OUT) :: b_next, v_value 
  DOUBLE PRECISION :: new_value, old_value, b_next_grid(num), STEP, b_next_guess, b_next_inf, &
  b_next_sup, b_tirar_inf, b_tirar_sup !, caca1, caca2
  DOUBLE PRECISION, EXTERNAL :: objective_function_excl

  b_next_inf = b_inf_short
  b_next_sup = b_sup_short
  
  !Note: below I initialize "index_opt" and "b_next_guess". In a normal work of the routine, these value will be overwritten.
  index_opt = 2
  b_next_guess = b_grid_short(2)

  old_value = 10d+3

  DO i=1,num
     b_next_grid(i) = b_next_inf + (b_next_sup - b_next_inf) * (i-1)/ (num - 1)
     new_value = objective_function_excl(b_next_grid(i))
     IF (new_value <= old_value) THEN
        index_opt = i
        b_next_guess = b_next_grid(i)
        old_value = new_value
     END IF
  END DO

!   write(*,*) 'index_opt', index_opt

  STEP = (b_next_grid(2) - b_next_grid(1))*0.5d+0

  b_tirar_inf = b_inf_short + 1.0d-4
  b_tirar_sup = b_sup_short - 1.0d-4

  IF (index_opt == 1) THEN
   ! caca1 = objective_function_excl(b_tirar_inf)
   ! caca2 = objective_function_excl(b_next_grid(index_opt))
   ! write(*,*) 'caca1',caca1, 'caca2',caca2
   ! write(*,*) 'HERE before'  

      IF(objective_function_excl(b_tirar_inf) > objective_function_excl(b_next_grid(index_opt))) THEN
         b_next = b_next_grid(index_opt)
         ! v_value = -old_value
         v_value = -objective_function_excl(b_next) !This looks inefficient, but it guarantees the *correct globals*
      ELSE
         b_next_guess = b_tirar_inf

         call fminsearch(b_next_guess,v_value,b_next_guess - STEP,b_next_guess + STEP,objective_function_excl)
         b_next = b_next_guess
         ! v_value = - v_value
         v_value = -objective_function_excl(b_next)
      end if
      ! write(*,*) ' OUTSIDE'
   ELSEIF(index_opt == num) THEN
      IF(objective_function_excl(b_tirar_sup) > objective_function_excl(b_next_grid(index_opt))) THEN
         b_next = b_next_grid(index_opt)
         ! v_value = -old_value
         v_value = -objective_function_excl(b_next)
      else
         b_next_guess = b_tirar_sup
         call fminsearch(b_next_guess,v_value,b_next_guess - STEP,b_next_guess + STEP, objective_function_excl)
         b_next = b_next_guess
         ! v_value = - v_value
         v_value = -objective_function_excl(b_next)
      END IF

   ELSE
      IF (ABS(old_value - objective_function_excl(b_next_grid(index_opt-1)))/(b_next_grid(2)-b_next_grid(1)) < 1d-10 .OR.  &
          ABS(old_value - objective_function_excl(b_next_grid(index_opt+1)))/(b_next_grid(2)-b_next_grid(1)) < 1d-10) THEN
        !function is too flat to invoke optimization routine
        b_next = b_next_guess
      !   v_value = -old_value
        v_value = -objective_function_excl(b_next)
      ELSE
         call fminsearch(b_next_guess,v_value,b_next_guess - STEP,b_next_guess + STEP, objective_function_excl)
         b_next = b_next_guess
         ! v_value = - v_value
         v_value = -objective_function_excl(b_next)
      END IF
   END IF

END SUBROUTINE optimize_excl


SUBROUTINE optimize_debt(b_next, v_value)
  USE param
  USE toolbox
  IMPLICIT NONE
  INTEGER :: MAXFN, index_opt, num, i
  PARAMETER (num=15)
  DOUBLE PRECISION :: b_next, v_value, new_value, old_value,&
       b_next_grid(num), STEP, BOUND, XACC, b_next_guess, b_tirar_sup, b_tirar_inf, b_next_inf, b_next_sup,&
       ancho, debt_inf, debt_sup
  DOUBLE PRECISION, EXTERNAL :: objective_function_debt,  q_menu_fun

  b_next_inf = b_inf
  b_next_sup = b_sup

  IF (indicator_global_search > 0) THEN  !SEARCH FOR BEST INITIAL GUESS USING ALL GRID RANGE
     old_value = 10d+15
     index_opt = 1
     DO i=1,num
        b_next_grid(i) = b_next_inf + (b_next_sup - b_next_inf) * (i-1)/ (num - 1)
        new_value = objective_function_debt(b_next_grid(i))        
      !   WRITE(*,*) 'Objctive_fun_DEBT ', new_value
      !   pause
      !   WRITE(*,*) 'cons', cons_t_global, 'labor', labor_global
        IF (new_value <= old_value) THEN
           index_opt = i
           b_next_guess = b_next_grid(i)
           old_value = new_value
        END IF
     END DO
  ELSE !FOCUS GRID SEARCH IN A NEIGHBORHOOD OF PREVIOUS OPTIMAL VALUE
   ancho = 0.25d+0
   !IF POLICY FUNCTIONS HAVE CONVERGED, USE PREVIOUS OPTIMAL VALUE FOR DEBT TO NARROW GRID SEARCH
   debt_inf = MAX(b_next_inf, b0_next_long_matrix(i_b_short_global, i_b_long_global, i_y_global, i_access_initial) - ancho)
   debt_sup = MIN(b_next_sup, b0_next_long_matrix(i_b_short_global, i_b_long_global, i_y_global, i_access_initial) + ancho)
   old_value = 10d+15
   index_opt = 1
   DO i=1,num
      !DEFINE THE GRID IN A NEIGHBORHOOD OF THE PREVIOUS OPTIMAL VALUE
      b_next_grid(i) = debt_inf + (debt_sup - debt_inf) * (i-1)/ (num - 1) !DEFINE GRID BASED ON PREVIOUS OPTIMAL VALUE
      new_value = objective_function_debt(b_next_grid(i))
      IF (new_value <= old_value) THEN
         index_opt = i
         b_next_guess = b_next_grid(i)
         old_value = new_value
      END IF
      !write(nout, '(I3, X, F12.8, X, I3, X, F12.8, X, F12.8)') i, b_next_grid(i), index_opt, new_value, &
      !q_menu_fun(b_short_global_optimize, b_next_grid(i), y_initial, i_access_initial)
      !write(100, '(F12.8, X, F12.8, X, F12.8)') b_next_grid(i), MIN(new_value, 100)
   END DO
END IF

  !CLOSE(100)
  !pause
  STEP = (b_next_grid(2) - b_next_grid(1))*0.5
  BOUND = 10*EXP(y_sup)
  XACC = 1d-5
  MAXFN = 1000


  b_tirar_sup = b_next_sup - 1.0d-4
  b_tirar_inf = b_next_inf + 1.0d-4

  if (index_opt == 1) then
      if ( objective_function_debt(b_tirar_inf) > objective_function_debt(b_next_grid(index_opt))) then
         b_next = b_next_grid(index_opt)
         v_value = old_value   
      else
         b_next_guess = b_tirar_inf
         call fminsearch(b_next_guess,v_value,b_next_inf,b_next_grid(2),objective_function_debt)
         b_next = b_next_guess
      end if
   
   ELSEIF(index_opt ==num) THEN
      if (objective_function_debt(b_tirar_sup) > objective_function_debt(b_next_grid(index_opt))) then
         b_next = b_next_grid(index_opt)
         v_value = old_value
      else
         b_next_guess = b_tirar_sup
         call fminsearch(b_next_guess,v_value,b_next_grid(num-1),b_next_sup,objective_function_debt)
         b_next = b_next_guess

      end if
   else
      IF (ABS(old_value - objective_function_debt(b_next_grid(index_opt-1)))/(b_next_grid(2)-b_next_grid(1)) < 1d-10 .OR.  &
      ABS(old_value - objective_function_debt(b_next_grid(index_opt+1)))/(b_next_grid(2)-b_next_grid(1)) < 1d-10) THEN
         b_next = b_next_guess
         v_value = old_value
      ELSE
         call fminsearch(b_next_guess,v_value,b_next_grid(index_opt-1),b_next_grid(index_opt+1),objective_function_debt)
         b_next = b_next_guess
      END IF
   end if

 !
 !
 !
 !  IF (index_opt == 1 .AND. objective_function_debt(b_tirar_inf) >= objective_function_debt(b_next_grid(index_opt))) THEN
 !     b_next = b_next_grid(index_opt)
 !     v_value = old_value
 !
 !  ELSEIF(index_opt == 1 .AND. objective_function_debt(b_tirar_inf) < objective_function_debt(b_next_grid(index_opt))) THEN
 !     !THE MAXIMUM MAY BE CLOSE TO MINIMUM GRID POINT BUT NOT AT MINIMUM GRID POINT
 !   !   b_next_guess = b_tirar_inf
 !   !   CALL DUVMIF(objective_function_debt, b_next_guess, STEP, BOUND, XACC, MAXFN, b_next)
 !   !   v_value = objective_function_debt(b_next)
 !
 !     b_next_guess = b_tirar_inf
 !     call fminsearch(b_next_guess,v_value,b_next_inf,b_next_grid(2),objective_function_debt)
 !     b_next = b_next_guess
 !       
 !
 !
 !  ELSEIF (index_opt == num .AND. objective_function_debt(b_tirar_sup) >= objective_function_debt(b_next_grid(index_opt))) THEN
 !     b_next = b_next_grid(index_opt)
 !     v_value = old_value
 !  ELSEIF(index_opt == num .AND. objective_function_debt(b_tirar_sup) < objective_function_debt(b_next_grid(index_opt))) THEN
 !     !THE MAXIMUM MAY BE CLOSE TO MAXIMUM GRID POINT BUT NOT AT MAXIMUM GRID POINT
 !   !   b_next_guess = b_tirar_sup
 !   !   CALL DUVMIF(objective_function_debt, b_next_guess, STEP, BOUND, XACC, MAXFN, b_next)
 !   !   v_value = objective_function_debt(b_next)
 !      b_next_guess = b_tirar_sup
 !      call fminsearch(b_next_guess,v_value,b_next_grid(num-1),b_next_sup,objective_function_debt)
 !      b_next = b_next_guess
 !
 !  ELSE
 !     IF (ABS(old_value - objective_function_debt(b_next_grid(index_opt-1)))/(b_next_grid(2)-b_next_grid(1)) < 1d-10 .OR.  &
 !          ABS(old_value - objective_function_debt(b_next_grid(index_opt+1)))/(b_next_grid(2)-b_next_grid(1)) < 1d-10) THEN
 !        b_next = b_next_guess
 !        v_value = old_value
 !     ELSE
 !
 !      !   CALL DUVMIF(objective_function_debt, b_next_guess, STEP, BOUND, XACC, MAXFN, b_next)
 !      !   v_value = objective_function_debt(b_next)
 !      call fminsearch(b_next_guess,v_value,b_next_grid(index_opt-1),b_next_grid(index_opt+1),objective_function_debt)
 !      b_next = b_next_guess
 !
 !     END IF
 !  END IF

END SUBROUTINE optimize_debt

! Function "interpolate" is not use. Commenting.
! DOUBLE PRECISION FUNCTION interpolate(net, y, matrix)
!   USE param
!   IMPLICIT NONE
!   DOUBLE PRECISION, INTENT(IN) :: net, y, matrix(net_num, y_num_finer)
!   DOUBLE PRECISION ::  slope, weight, acum, ratio_net, ratio_y
!   INTEGER :: index_net, index_y, i_net, i_y
!   index_y = (MAX(MIN(INT((y_num_finer-1)*(y-y_grid_finer(1))/(y_grid_finer(y_num_finer)-y_grid_finer(1)))+1,y_num_finer-1), 1))
!   index_net = (MAX(MIN(INT((net_num-1)*(net-net_grid(1))/(net_grid(net_num)-net_grid(1)))+1,net_num-1), 1))
!   ratio_net = (net - net_grid(index_net)) / (net_grid(index_net+1) - net_grid(index_net))
!   ratio_y = (y - y_grid_finer(index_y)) / (y_grid_finer(index_y+1) - y_grid_finer(index_y))
!   acum=0
!   DO i_net=0,1
   !   DO i_y=0,1
      !   weight = ((1-i_net)*(1 - ratio_net) + i_net*ratio_net )* ((1-i_y)*(1 - ratio_y) + i_y*ratio_y )
      !   acum = acum + matrix(index_net + i_net, index_y + i_y)*weight
   !   END DO
!   END DO
!   interpolate = acum
! END FUNCTION interpolate


!FUNCTION THAT APPROXIMATES THE blong LEVEL AT WHICH q(bshort, blong, y, m) = qbar IF THERE IS SUCH VALUE
!FOR blong IN [b_inf, b_sup]
DOUBLE PRECISION FUNCTION b_limit_fun_spline(b_short, y, index_access)
  USE param
  USE toolbox
  IMPLICIT NONE
  DOUBLE PRECISION, INTENT(IN) :: b_short, y
  INTEGER, INTENT(IN) :: index_access
  DOUBLE PRECISION ::  slope, value_left, value_right
  INTEGER :: index_y

  index_y = (MAX(MIN(INT((y_num_finer-1)*(y-y_grid_finer(1))/(y_grid_finer(y_num_finer)-y_grid_finer(1)))+1,y_num_finer-1), 1))
  
  value_left = spline_eval(b_short, coeff_matrix_b_limit(:,index_y, index_access),b_grid_short_finer(1) ,&
  b_grid_short_finer(b_num_short_finer))
  
  value_right = spline_eval(b_short, coeff_matrix_b_limit(:,index_y+1, index_access),b_grid_short_finer(1) ,&
  b_grid_short_finer(b_num_short_finer))

  slope = (value_right - value_left)/ (y_grid_finer(index_y+1) - y_grid_finer(index_y))
  b_limit_fun_spline = value_left + slope*(y - y_grid_finer(index_y))

END FUNCTION b_limit_fun_spline


DOUBLE PRECISION FUNCTION v0_fun(b_short, b_long, y, index_access)
  USE param
  USE toolbox
  IMPLICIT NONE

  DOUBLE PRECISION, INTENT(IN) :: b_short, b_long, y
  INTEGER, INTENT(IN) :: index_access
  DOUBLE PRECISION ::  slope, value_left, value_right, bs, bl, vector_eval(2), vector_low(2), vector_high(2)
  INTEGER :: index_y
   ! vector = (y-y_grid)**2
   ! index_y = MINLOC(vector, DIM=1)

   index_y = (MAX(MIN(INT((y_num-1)*(y-y_grid(1))/(y_grid(y_num)-y_grid(1)))+1,y_num-1), 1))

  !BOUNDARY VALUES ARE ADJUSTED SO THAT bs AND bl ARE ALWAYS WITHING THE GRID REGION
  bs=  MIN(MAX(b_inf_short+1d-6, b_short),b_sup_short-1d-6)
  bl=  MIN(MAX(b_inf+1d-6, b_long),b_sup-1d-6)
  
  vector_eval(1) = bs
  vector_eval(2) = bl

  vector_low(1) = b_grid_short(1)
  vector_low(2) = b_grid_long(1)

  vector_high(1) = b_grid_short(b_num_short)
  vector_high(2) = b_grid_long(b_num_long)

  value_left = spline_eval(vector_eval, coeff_matrix_v0(:,:,index_y, index_access),vector_low , vector_high)
  value_right= spline_eval(vector_eval, coeff_matrix_v0(:,:,index_y+1, index_access),vector_low , vector_high)

  slope = (value_right - value_left)/ (y_grid(index_y+1) - y_grid(index_y))

  v0_fun = value_left + slope * (y - y_grid(index_y))

END FUNCTION v0_fun


DOUBLE PRECISION FUNCTION v1_fun(b_short, b_long, y, index_access)
  USE param
  IMPLICIT NONE
  DOUBLE PRECISION, INTENT(IN) :: b_short, b_long, y
  INTEGER, INTENT(IN) :: index_access
  DOUBLE PRECISION, EXTERNAL :: interpolate3

  v1_fun = interpolate3(b_short, b_long, y, v1_matrix(:,:,:, index_access))

END FUNCTION v1_fun

! Function to interpolate linearly over 3D. For now, let's keep it.
DOUBLE PRECISION FUNCTION interpolate3(bs, bl, y, matrix)
  USE param
  IMPLICIT NONE

  DOUBLE PRECISION, INTENT(IN) :: bs, bl, y, matrix(b_num_short, b_num_long, y_num)
  DOUBLE PRECISION ::  weight, acum, ratio_bs, ratio_bl, ratio_y, eps
  INTEGER :: index_bs, index_bl, index_y, i_bs, i_bl, i_y

  eps = 1d-8 !NEEDED TO ADD EPSILON BECAUSE IF y = y_grid(i) IT MAY CHOOSE index_y = i-1 DUE TO APPROX ERROR IN THE ROUNDING
  index_y = MAX(MIN(INT((y_num-1)*(y+eps-y_grid(1))/(y_grid(y_num)-y_grid(1)))+1,y_num-1), 1)
  index_bs = MAX(MIN(INT((b_num_short-1)*(bs+eps-b_grid_short(1))/(b_grid_short(b_num_short)-b_grid_short(1)))+1,b_num_short-1), 1)
  index_bl = MAX(MIN(INT((b_num_long -1)*(bl+eps-b_grid_long(1)) /(b_grid_long(b_num_long)-b_grid_long(1)))+1,b_num_long-1), 1)

  ratio_bs = (bs - b_grid_short(index_bs)) / (b_grid_short(index_bs+1) - b_grid_short(index_bs))
  ratio_bl = (bl - b_grid_long(index_bl)) / (b_grid_long(index_bl+1) - b_grid_long(index_bl))
  ratio_y = (y - y_grid(index_y)) / (y_grid(index_y+1) - y_grid(index_y))
  acum=0

  DO i_bs=0,1
     DO i_bl = 0,1
        DO i_y=0,1
           weight = ((1-i_bs)*(1 - ratio_bs) + i_bs*ratio_bs) * ((1-i_bl)*(1 - ratio_bl) + i_bl*ratio_bl) * &
                ((1-i_y)*(1 - ratio_y) + i_y*ratio_y )
           acum = acum + matrix(index_bs + i_bs, index_bl + i_bl, index_y + i_y)*weight
        END DO
     END DO
  END DO

  interpolate3 = acum
END FUNCTION interpolate3


DOUBLE PRECISION FUNCTION q_paid_fun(b_short, b_long, y, index_access)
  USE param
  IMPLICIT NONE
  DOUBLE PRECISION, INTENT(IN) :: b_short, b_long, y
  INTEGER, INTENT(IN) :: index_access
  DOUBLE PRECISION, EXTERNAL:: interpolate3

  q_paid_fun = interpolate3(b_short, b_long, y, q_nodef_matrix(:,:,:, index_access))

END FUNCTION q_paid_fun



DOUBLE PRECISION FUNCTION EV_fun(b_short, b_long, y, index_access)
  USE param
  USE toolbox
  IMPLICIT NONE
  DOUBLE PRECISION, INTENT(IN) :: b_short, b_long, y
  INTEGER, INTENT(IN) :: index_access
  DOUBLE PRECISION ::  slope, value_left, value_right, bs, bl, vector_eval(2), vector_low(2), vector_high(2)
  INTEGER :: index_y
  
  index_y = (MAX(MIN(INT((y_num_finer-1)*(y-y_grid_finer(1))/(y_grid_finer(y_num_finer)-y_grid_finer(1)))+1,y_num_finer-1), 1))
  
  !BOUNDARY VALUES ARE ADJUSTED SO THAT bs AND bl ARE ALWAYS WITHING THE GRID REGION
  bs=  MIN(MAX(b_inf_short+1d-6, b_short),b_sup_short-1d-6)
  bl=  MIN(MAX(b_inf+1d-6, b_long),b_sup-1d-6)
  
  vector_eval(1) = bs
  vector_eval(2) = bl

  vector_low(1) = b_grid_short_finer(1)
  vector_low(2) = b_grid_long_finer(1)

  vector_high(1) = b_grid_short_finer(b_num_short_finer)
  vector_high(2) = b_grid_long_finer(b_num_long_finer)

  value_left = spline_eval(vector_eval, coeff_matrix_ev(:,:,index_y, index_access),vector_low , vector_high)
  value_right= spline_eval(vector_eval, coeff_matrix_ev(:,:,index_y+1, index_access),vector_low , vector_high)

  slope = (value_right - value_left)/ (y_grid_finer(index_y+1) - y_grid_finer(index_y))
  EV_fun= value_left + slope * (y - y_grid_finer(index_y))

END FUNCTION EV_fun


DOUBLE PRECISION FUNCTION EV_excl_fun(b_short, b_long, y, index_access)
  USE param
  USE toolbox
  IMPLICIT NONE
  DOUBLE PRECISION, INTENT(IN) :: b_short, b_long, y
  INTEGER, INTENT(IN) :: index_access
  DOUBLE PRECISION ::  slope, value_left, value_right, bs, bl, vector_eval(2), vector_low(2), vector_high(2)
  INTEGER :: index_y
  
  index_y = (MAX(MIN(INT((y_num_finer-1)*(y-y_grid_finer(1))/(y_grid_finer(y_num_finer)-y_grid_finer(1)))+1,y_num_finer-1), 1))
  
  !BOUNDARY VALUES ARE ADJUSTED SO THAT bs AND bl ARE ALWAYS WITHING THE GRID REGION
  bs=  MIN(MAX(b_inf_short+1d-6, b_short),b_sup_short-1d-6)
  bl=  MIN(MAX(b_inf+1d-6, b_long),b_sup-1d-6)

  vector_eval(1) = bs
  vector_eval(2) = bl

  vector_low(1) = b_grid_short_finer(1)
  vector_low(2) = b_grid_long_finer(1)

  vector_high(1) = b_grid_short_finer(b_num_short_finer)
  vector_high(2) = b_grid_long_finer(b_num_long_finer)

  value_left = spline_eval(vector_eval, coeff_matrix_ev_excl(:,:,index_y, index_access),vector_low , vector_high)
  value_right= spline_eval(vector_eval, coeff_matrix_ev_excl(:,:,index_y+1, index_access),vector_low , vector_high)

  slope = (value_right - value_left)/ (y_grid_finer(index_y+1) - y_grid_finer(index_y))
  EV_excl_fun= value_left + slope * (y - y_grid_finer(index_y))

END FUNCTION EV_excl_fun



DOUBLE PRECISION FUNCTION q_menu_fun(b_short, b_long, y, index_access)
  USE param
  USE toolbox
  IMPLICIT NONE
  DOUBLE PRECISION, INTENT(IN) :: b_short, b_long, y
  INTEGER, INTENT(IN) :: index_access
  DOUBLE PRECISION ::  slope, value_left, value_right, bs, bl, vector_eval(2), vector_low(2), vector_high(2)
  INTEGER :: index_y
  
  index_y = (MAX(MIN(INT((y_num_finer-1)*(y-y_grid_finer(1))/(y_grid_finer(y_num_finer)-y_grid_finer(1)))+1,y_num_finer-1), 1))
  
  !BOUNDARY VALUES ARE ADJUSTED SO THAT bs AND bl ARE ALWAYS WITHING THE GRID REGION
  bs=  MIN(MAX(b_inf_short+1d-6, b_short),b_sup_short-1d-6)
  bl=  MIN(MAX(b_inf+1d-6, b_long),b_sup-1d-6)

  vector_eval(1) = bs
  vector_eval(2) = bl

  vector_low(1) = b_grid_short_finer(1)
  vector_low(2) = b_grid_long_finer(1)

  vector_high(1) = b_grid_short_finer(b_num_short_finer)
  vector_high(2) = b_grid_long_finer(b_num_long_finer)

  value_left = spline_eval(vector_eval, coeff_matrix_q_menu(:,:,index_y, index_access),vector_low , vector_high)
  value_right= spline_eval(vector_eval, coeff_matrix_q_menu(:,:,index_y+1, index_access),vector_low , vector_high)

  slope = (value_right - value_left)/ (y_grid_finer(index_y+1) - y_grid_finer(index_y))
  q_menu_fun  = value_left + slope * (y - y_grid_finer(index_y))

END FUNCTION q_menu_fun

DOUBLE PRECISION FUNCTION def_prob_tomorrow_interp_fun(b_short, b_long, y, index_access)
  USE param
  USE toolbox
  IMPLICIT NONE
  DOUBLE PRECISION, INTENT(IN) :: b_short, b_long, y
  INTEGER, INTENT(IN) :: index_access
  DOUBLE PRECISION ::  slope, value_left, value_right, bs, bl, vector_eval(2), vector_low(2), vector_high(2)
  INTEGER :: index_y
  
  index_y = (MAX(MIN(INT((y_num_finer-1)*(y-y_grid_finer(1))/(y_grid_finer(y_num_finer)-y_grid_finer(1)))+1,y_num_finer-1), 1))
  
  !BOUNDARY VALUES ARE ADJUSTED SO THAT bs AND bl ARE ALWAYS WITHING THE GRID REGION
  bs=  MIN(MAX(b_inf_short+1d-6, b_short),b_sup_short-1d-6)
  bl=  MIN(MAX(b_inf+1d-6, b_long),b_sup-1d-6)

  vector_eval(1) = bs
  vector_eval(2) = bl

  vector_low(1) = b_grid_short_finer(1)
  vector_low(2) = b_grid_long_finer(1)

  vector_high(1) = b_grid_short_finer(b_num_short_finer)
  vector_high(2) = b_grid_long_finer(b_num_long_finer)

  value_left = spline_eval(vector_eval, coeff_matrix_def_prob(:,:,index_y, index_access),vector_low , vector_high)
  value_right= spline_eval(vector_eval, coeff_matrix_def_prob(:,:,index_y+1, index_access),vector_low , vector_high)

  slope = (value_right - value_left)/ (y_grid_finer(index_y+1) - y_grid_finer(index_y))
  def_prob_tomorrow_interp_fun  = value_left + slope * (y - y_grid_finer(index_y))
  
  def_prob_tomorrow_interp_fun = min(max(def_prob_tomorrow_interp_fun, zero),one)

END FUNCTION def_prob_tomorrow_interp_fun

DOUBLE PRECISION FUNCTION b_limit_fun(bnext)
  USE param
  IMPLICIT NONE
  DOUBLE PRECISION, INTENT(in) :: bnext
  DOUBLE PRECISION, EXTERNAL :: q_menu_fun

  b_limit_fun =  q_menu_fun(b_short_next_global, bnext, y_initial, i_access_initial) - q_global
END FUNCTION b_limit_fun


!COMPUTE MATRICES AND SPLINE COEFFICIENTS FOR q(bs, bl, y) and E[V(bs, bl, y') | y)]
SUBROUTINE compute_q_ev
  USE param
  USE toolbox
  IMPLICIT NONE
  INTEGER :: i_b_short, i_b_long, i_y, i, i_access, index_access_next
  logical :: check_return
  DOUBLE PRECISION :: b_short, b_long, y_threshold, cdf_threshold, exp_v_next, scalar, y_min, y_max, acum1, acum2, acum(2), &
  cdf, cdf1, y_next, y_next1, value_next, exp_v_excl, exp_v_excl_ends, &
  FDATA(b_num_short_finer), FDATA_2D_finer(b_num_short_finer, b_num_long_finer), left, right, valor
  DOUBLE PRECISION, DIMENSION (b_num_short_finer, b_num_long_finer, y_num_finer, 2) ::&
   EV_matrix, q_menu_matrix, EV_excl_matrix, q1_menu_matrix, def_prob_matrix
  DOUBLE PRECISION, DIMENSION (b_num_short_finer, y_num_finer, 2) :: blong_limit_matrix
  DOUBLE PRECISION, EXTERNAL :: y_fun, v0_fun, v1_fun, q_fun, q_menu_fun, b_limit_fun, b_limit_fun_spline, q1_fun,&
  def_prob_tomorrow_fun


  DO i_access = 1,2
     i_access_initial = i_access
     DO i_y = 1,y_num_finer
        y_initial = y_grid_finer(i_y)
        DO i_b_short = 1, b_num_short_finer
           b_short = b_grid_short_finer(i_b_short)
           DO i_b_long = 1, b_num_long_finer
              b_long = b_grid_long_finer(i_b_long)
              DO index_access_next = 1,access_num

                 !COMPUTE EXPECTED VALUE FUNCTION FOR THE NEXT PERIOD IF IT CHOOSES A PORTFOLIO (b_short, b_long)
                 !WHEN CURRENT INCOME = y_initial
                 y_threshold   = y_fun(b_short, b_long, index_access_next)
                 cdf_threshold = normalCDF((y_threshold - rho*y_initial - (1d+0-rho)* mean_y)/std_eps)

                 exp_v_next = 0d+0
                 scalar = 1d+0 / SQRT(pi_number)

                 y_min = (1d+0-rho)*mean_y + rho* y_initial - 4d+0*std_eps
                 y_max = (1d+0-rho)*mean_y + rho* y_initial + 4d+0*std_eps

                 acum1=0d+0
                 acum2=0d+0


                 IF (cdf_threshold <= cdf_inf) THEN
                    DO i=1,quad_num_v
                       cdf = 0.5d+0*(quad_x_v(i) + 1d+0)*(cdf_sup - cdf_inf) + cdf_inf
                       y_next  = (1d+0-rho)*mean_y + rho* y_initial + normalCDF_Inv(cdf) * std_eps
                       value_next = v0_fun(b_short, b_long, y_next, index_access_next)
                       acum1 = acum1 + 0.5d+0*(cdf_sup - cdf_inf)*quad_w_v(i) * value_next
                    END DO
                 ELSEIF(cdf_threshold >= cdf_sup) THEN

                    DO i=1,eps_num
                       cdf = 0.5d+0*(quad_x_v(i) + 1d+0)*(cdf_sup - cdf_inf) + cdf_inf
                       y_next  = (1d+0-rho)*mean_y + rho* y_initial + normalCDF_Inv(cdf) * std_eps
                       value_next = v1_fun(b_short, b_long, y_next, index_access_next)
                       acum1 = acum1 + 0.5d+0*(cdf_sup - cdf_inf)*quad_w_v(i) * value_next
                    END DO

                 ELSE
                    DO i=1,eps_num

                       cdf = 0.5d+0*(quad_x_v(i) + 1d+0)*(cdf_threshold - cdf_inf) + cdf_inf
                       y_next  = (1d+0-rho)*mean_y + rho* y_initial + normalCDF_Inv(cdf) * std_eps
                       value_next = v1_fun(b_short, b_long, y_next, index_access_next)
                       acum1 = acum1 + 0.5d+0*(cdf_threshold - cdf_inf)*quad_w_v(i) * value_next

                       cdf1 = 0.5d+0*(quad_x_v(i) + 1d+0)*(cdf_sup - cdf_threshold) + cdf_threshold
                       y_next1 = (1d+0-rho)*mean_y + rho* y_initial + normalCDF_Inv(cdf1) * std_eps
                       value_next = v0_fun(b_short, b_long, y_next1, index_access_next)
                       acum2 = acum2 + 0.5d+0*(cdf_sup - cdf_threshold)*quad_w_v(i) * value_next
                    END DO
                 END IF
                 acum(index_access_next) = trans_matrix(i_access, index_access_next) * (acum1+acum2)/(cdf_sup - cdf_inf)
              END DO

              EV_matrix(i_b_short, i_b_long, i_y, i_access) = SUM(acum)
              q_menu_matrix(i_b_short, i_b_long, i_y, i_access) = q_fun(b_short, b_long, y_initial, i_access)

              q1_menu_matrix(i_b_short, i_b_long, i_y, i_access) = q1_fun(b_short, b_long, y_initial, i_access)

              def_prob_matrix(i_b_short, i_b_long, i_y, i_access) = def_prob_tomorrow_fun(b_short, b_long, y_initial, i_access)

              !COMPUTE EXPECTED VALUE FUNCTION FOR THE NEXT PERIOD IF EXCLUDED AND CHOOSES A PORTFOLIO (b_short)
              !WHEN CURRENT INCOME = y_initial

              acum = 0d+0
              DO index_access_next = 1,access_num
                 exp_v_excl      = 0d+0
                 exp_v_excl_ends = 0d+0
                 scalar = 1d+0 / SQRT(pi_number)

                 DO i=1,quad_num_v
                    !CONTINUES EXCLUDED IN THE NEXT PERIOD (NO BORROWING AND DEFAULT COST)
                    cdf = 0.5d+0*(quad_x_v(i) + 1d+0)*(cdf_sup - cdf_inf) + cdf_inf
                    y_next  = (1d+0-rho)*mean_y + rho* y_initial + normalCDF_Inv(cdf) * std_eps
                    value_next = v1_fun(b_short, b_long, y_next, index_access_next)
                    exp_v_excl = exp_v_excl + 0.5d+0*(cdf_sup - cdf_inf)*quad_w_v(i) * value_next

                    !EXCLUSION ENDS IN THE NEXT PERIOD (STARTS WITH RECOVERY DEBT b_recov AND DECIDES WHETHER TO DEFAULT)
                    value_next = MAX(v0_fun(b_short, MIN(b_recov, b_long), y_next, index_access_next), &
                         v1_fun(b_short, MIN(b_recov, b_long), y_next, index_access_next))
                    exp_v_excl_ends = exp_v_excl_ends + 0.5d+0*(cdf_sup - cdf_inf)*quad_w_v(i) * value_next

                 END DO
                 acum(index_access_next) = trans_matrix(i_access, index_access_next) * &
                      ((1d+0 - prob_excl_end) * exp_v_excl + prob_excl_end * exp_v_excl_ends)/(cdf_sup - cdf_inf)
              END DO

              EV_excl_matrix(i_b_short, i_b_long, i_y, i_access) = SUM(acum)
           END DO
        END DO
     END DO
  END DO

  !COMPUTE COEFFICIENTS OF MATRIX
  DO i_access = 1,access_num
     DO i_y = 1,y_num_finer

        FDATA_2D_finer = EV_matrix(:,:,i_y,i_access)
        call spline_interp(FDATA_2D_finer, coeff_matrix_ev(:,:,i_y,i_access))

        FDATA_2D_finer = q_menu_matrix(:,:,i_y,i_access)
        call spline_interp(FDATA_2D_finer, coeff_matrix_q_menu(:,:,i_y,i_access))

        FDATA_2D_finer = q1_menu_matrix(:,:,i_y,i_access)
        call spline_interp(FDATA_2D_finer, coeff_matrix_q1_menu(:,:,i_y,i_access))

        FDATA_2D_finer = def_prob_matrix(:,:,i_y,i_access)
        call spline_interp(FDATA_2D_finer, coeff_matrix_def_prob(:,:,i_y,i_access))

        FDATA_2D_finer = EV_excl_matrix(:,:,i_y,i_access)
        call spline_interp(FDATA_2D_finer, coeff_matrix_ev_excl(:,:,i_y,i_access))

     END DO
  END DO

  !USE THE SPLINE COEFFICIENTS FOR q_menu_fun TO CALCULATE THE blong LEVELS AT WHICH q(bshort, blong, y, m) = qbar IF THERE IS SUCH VALUE
  !FOR blong IN [b_inf, b_sup]

  DO i_access = 1,access_num
     i_access_initial = i_access
     DO i_y = 1,y_num_finer
        y_initial = y_grid_finer(i_y)
        DO i_b_short = 1, b_num_short_finer
           b_short = b_grid_short_finer(i_b_short)
           b_short_next_global = b_short
           IF (q_menu_fun(b_short, b_sup, y_initial, i_access_initial) >= q_global) THEN
              blong_limit_matrix(i_b_short, i_y, i_access) = b_sup
           ELSEIF  (q_menu_fun(b_short, b_sup, y_initial, i_access_initial) < q_global .AND. &
                q_menu_fun(b_short, b_inf, y_initial, i_access_initial) > q_global) THEN
              !MAXIMUM DEBT > b*(1-delta). CAN ISSUE LONG-TERM DEBT UNTIL q(b)=qbar

              left = b_inf
              right = b_sup
              valor = (left+right)/2d+0
              call fzero(valor, b_limit_fun,check_return)
              blong_limit_matrix(i_b_short, i_y, i_access) = valor

           ELSE
              !MAXIMUM DEBT = b_inf. CAN BUY BACK DEBT BUT CANNOT ISSUE NEW LONG-TERM DEBT
              blong_limit_matrix(i_b_short, i_y, i_access) = b_inf
           END IF
        END DO
     END DO
  END DO


  DO i_access = 1,access_num
     DO i_y = 1,y_num_finer
        FDATA = blong_limit_matrix(:,i_y,i_access)
        call spline_interp(FDATA, coeff_matrix_b_limit(:,i_y,i_access))

     END DO
  END DO


!   OPEN(100, FILE ='coeff_excl.txt',STATUS='replace')
!   OPEN(101, FILE ='coeff_EV.txt',STATUS='replace')
!   OPEN(102, FILE ='coeff_q.txt',STATUS='replace')
!   OPEN(103, FILE ='coeff_blimit.txt',STATUS='replace')
  OPEN(104, FILE ='EV.txt',STATUS='replace')

  DO i_access = 1,access_num
     DO i_y = 1,y_num_finer
        DO i_b_short = 1,b_num_short_finer
         !   WRITE(103, '(F20.8, X, F20.8, X, F20.8, X, F20.8, X, F20.8)') break_matrix_b_limit(i_b_short,i_y, i_access), &
               !  coeff_matrix_b_limit(1,i_b_short,i_y, i_access), coeff_matrix_b_limit(2,i_b_short,i_y, i_access),&
               !  coeff_matrix_b_limit(3,i_b_short,i_y, i_access), coeff_matrix_b_limit(4,i_b_short,i_y, i_access)
           DO i_b_long = 1,b_num_long_finer

            !   WRITE(100, '(F20.8)') coeff_matrix_EV_excl(i_b_short, i_b_long, i_y, i_access)
            !   WRITE(101, '(F20.8)') coeff_matrix_EV(i_b_short, i_b_long, i_y, i_access)
            !   WRITE(102, '(F20.8)') coeff_matrix_q_menu(i_b_short, i_b_long, i_y, i_access)
              WRITE(104, '(F20.8)') EV_matrix(i_b_short, i_b_long, i_y, i_access)
           END DO
        END DO
     END DO
  END DO
!   CLOSE(100)
!   CLOSE(101)
!   CLOSE(102)
!   CLOSE(103)
  CLOSE(104)

END SUBROUTINE compute_q_ev


! read_q_ev: not used. Commenting.
! SUBROUTINE read_q_ev
!   USE param
!   IMPLICIT NONE
! 
!   INTEGER :: i_b_short, i_b_long, i_y, i, i_access, index_access_next
! 
!   OPEN(100, FILE ='coeff_excl.txt')
!   OPEN(101, FILE ='coeff_EV.txt')
!   OPEN(102, FILE ='coeff_q.txt')
!   OPEN(103, FILE ='coeff_blimit.txt')
!   DO i_access = 1,access_num
   !   DO i_y = 1,y_num_finer
      !   DO i_b_short = 1,b_num_short_finer
         !   READ(103, '(F20.8, X, F20.8, X, F20.8, X, F20.8, X, F20.8)') break_matrix_b_limit(i_b_short,i_y, i_access), &
               !  coeff_matrix_b_limit(1,i_b_short,i_y, i_access), coeff_matrix_b_limit(2,i_b_short,i_y, i_access), &
               !  coeff_matrix_b_limit(3,i_b_short,i_y, i_access), coeff_matrix_b_limit(4,i_b_short,i_y, i_access)
         !   DO i_b_long = 1,b_num_long_finer
            !   READ(100, '(F20.8)') coeff_matrix_EV_excl(i_b_short, i_b_long, i_y, i_access)
            !   READ(101, '(F20.8)')     coeff_matrix_EV(i_b_short, i_b_long, i_y, i_access)
            !   READ(102, '(F20.8)') coeff_matrix_q_menu(i_b_short, i_b_long, i_y, i_access)
         !   END DO
      !   END DO
   !   END DO
!   END DO
!   CLOSE(100)
!   CLOSE(101)
!   CLOSE(102)
!   CLOSE(103)
! 
! END SUBROUTINE read_q_ev


SUBROUTINE iterate
   USE param
   USE toolbox
   IMPLICIT NONE
   INTEGER :: d, i_b_short, i_b_long, i_y, i_access, counter_final
   DOUBLE PRECISION :: v_valor, convergence, criteria, deviation, b_next_short,&
   g, b0_next(2), b1_next(2), q_value, dev_q, dev_debt, dev_res, FDATA_2D(b_num_short,b_num_long), dev_sofar
   DOUBLE PRECISION, DIMENSION(b_num_short, b_num_long,  y_num, 2) :: v0_matrix_new, v1_matrix_new, q_nodef_matrix_new, &
   output_t_0_matrix, output_t_1_matrix,&
   cons_t_0_matrix, cons_t_1_matrix,labor_0_matrix, labor_1_matrix, wage_0_matrix, wage_1_matrix, dev_matrix, dev_matrix_q,&
   v_matrix_new, q_paid_matrix_new, b0_next_short_matrix_new, b0_next_long_matrix_new, b1_next_short_matrix_new,&
   loan_0_matrix, loan_1_matrix , rate_0_matrix, rate_1_matrix
   DOUBLE PRECISION, EXTERNAL :: q_fun, objective_function_excl, q_menu_fun, def_prob_tomorrow_interp_fun
   
   criteria = 1.0d-4   !CRITERIA FOR CONVERGENCE
   convergence = -1d+0
   indicator_global_search = 1d+0
   counter_final = 0
   dev_sofar = 10d+0

   DO WHILE(convergence<zero)
      deviation = zero
      dev_q =zero
      dev_res = zero
      dev_debt = zero
      counter = counter + 1
      counter_final = counter_final + 1
      q_global =  kappa* coupon*(1d+0-((1d+0-delta)*EXP(-rw))**counter)/(rw+delta)

      DO i_access = 1,access_num
         DO i_y = 1,y_num
            FDATA_2D = v0_matrix(:,:,i_y,i_access)
            call spline_interp(FDATA_2D, coeff_matrix_v0(:,:,i_y,i_access))

            FDATA_2D = q_nodef_matrix(:,:,i_y,i_access)
            call spline_interp(FDATA_2D, coeff_matrix_q(:,:,i_y,i_access))
         END DO
      END DO
      
!      if (dev_sofar < 1d+0 * 1d-3) then !Switch off indicator_global_search once and for all. -- This works for d1=1.5
 !        indicator_global_search = -1d+0
 !        ! ELSEIF (dev_sofar < 1d-3 .AND. counter > 300)then
 !        ELSEIF (counter > 200)then
 !        indicator_global_search = -1d+0
 !     end if

      CALL compute_q_ev !COMPUTE MATRICES OF SPLINE COEFFICIENTS TO APPROXIMATE EXPECTED VALUE FUNCTIONS AND BOND PRICE FUNCTION

      DO i_access = 1,access_num
         i_access_initial = i_access
         DO i_y = 1,y_num
            i_y_global = i_y
            y_initial = y_grid(i_y)
            DO i_b_short =  1, b_num_short
               i_b_short_global = i_b_short
               b_short_initial = b_grid_short(i_b_short)

               i_b_long_global = 1 !1st item in the grid, very close to zero
               b_long_initial = b_grid_long(i_b_long_global)
               i_default_global=2 !Country defaults
               ! WRITE(*,*) 'BEFORE OPTIMIZE EXCL'
               CALL optimize_excl(b_next_short, v_valor)

               b1_next(1) = b_next_short
               b1_next(2) = b_long_initial*EXP(rw)
               
               disut_default = d0 + d1*y_initial
               ! disut_default = max(zero,d0 + d1*y_initial)
               v1_matrix_new(i_b_short, :, i_y_global, i_access) = v_valor - omega* disut_default
               b1_next_short_matrix_new(i_b_short, :, i_y_global, i_access) = b1_next(1)
               

               cons_t_1_matrix(i_b_short, :, i_y_global, i_access) = cons_t_global               
               output_t_1_matrix(i_b_short, :, i_y_global, i_access) = output_t_global               
               labor_1_matrix(i_b_short, :, i_y_global, i_access) = labor_global
               wage_1_matrix(i_b_short, :, i_y_global, i_access) = wage_global
               loan_1_matrix(i_b_short, :, i_y_global, i_access) = loan_global
               rate_1_matrix(i_b_short, :, i_y_global, i_access) = rate_global


            end do
         end do
      end do
      
      ! write(*,*) 'after first loop'

      DO i_access = 1,access_num
         ! write(*,*) 'i_k = ', i_access
         i_access_initial = i_access
         DO i_y = 1,y_num
            ! write(*,*) 'i_y = ', i_y
            i_y_global = i_y
            y_initial = y_grid(i_y)
            DO i_b_short =  1, b_num_short
               ! write(*,*) 'i_a = ', i_b_short
               i_b_short_global = i_b_short
               b_short_initial = b_grid_short(i_b_short)
               DO i_b_long = 1, b_num_long
                  ! write(*,*) 'ik= ', i_access, 'iy= ', i_y,'ia= ',i_b_short, 'i_b = ', i_b_long

                  i_b_long_global = i_b_long
                  b_long_initial = b_grid_long(i_b_long)

                  i_default_global=1   ! Country does not default and is not excluded for the next period
                  i_excl_global=1                  

                  CALL optimize(b0_next, v_valor)
                  ! b0_next = zero
                  v0_matrix_new(i_b_short, i_b_long, i_y, i_access) = v_valor
                  b0_next_short_matrix_new(i_b_short, i_b_long, i_y_global, i_access) = b0_next(1)
                  b0_next_long_matrix_new(i_b_short, i_b_long, i_y_global, i_access)  = b0_next(2)
                  v0_matrix_new(i_b_short, i_b_long, i_y, i_access) = v_valor

                  cons_t_0_matrix(i_b_short, i_b_long, i_y_global, i_access) = cons_t_global
                  output_t_0_matrix(i_b_short, i_b_long, i_y_global, i_access) = output_t_global
                  labor_0_matrix(i_b_short,i_b_long, i_y_global, i_access) = labor_global
                  wage_0_matrix(i_b_short, i_b_long, i_y_global, i_access) = wage_global
                  loan_0_matrix(i_b_short, i_b_long, i_y_global, i_access) = loan_global
                  rate_0_matrix(i_b_short, i_b_long, i_y_global, i_access) = rate_global

                  q_nodef_matrix_new(i_b_short, i_b_long, i_y_global, i_access) = q_fun(b0_next(1), b0_next(2), y_initial, i_access)

                  IF (v1_matrix_new(i_b_short, i_b_long, i_y, i_access) > v0_matrix_new(i_b_short, i_b_long, i_y, i_access)) THEN
                   default_decision(i_b_short, i_b_long, i_y, i_access) = 2
                   b_next_matrix(i_b_short, i_b_long,  i_y, i_access, 1) = &
                   b1_next_short_matrix_new(i_b_short, i_b_long, i_y_global, i_access)
                   b_next_matrix(i_b_short, i_b_long,  i_y, i_access, 2) =  b1_next(2)
                   q_paid_matrix_new(i_b_short, i_b_long, i_y_global, i_access) =  &
                   q_fun(b1_next_short_matrix_new(i_b_short, i_b_long, i_y_global, i_access), b_long_initial*EXP(rw),&
                   y_initial,i_access)

                  ELSE

                   default_decision(i_b_short, i_b_long, i_y, i_access) = 1
                   b_next_matrix(i_b_short, i_b_long,  i_y, i_access, 1) = b0_next(1)  !SAVINGS IF NO DEFAULT
                   b_next_matrix(i_b_short, i_b_long,  i_y, i_access, 2) = b0_next(2) !SAVINGS IF NO DEFAULT
                   q_paid_matrix_new(i_b_short, i_b_long, i_y_global, i_access) =  q_fun(b0_next(1),b0_next(2),y_initial,i_access)
                  END IF

                  v_matrix_new(i_b_short, i_b_long, i_y, i_access) = MAX(v1_matrix_new(i_b_short, i_b_long, i_y, i_access), &
                  v0_matrix_new(i_b_short, i_b_long, i_y, i_access))

                  deviation = MAX(deviation, ABS(v_matrix_new(i_b_short, i_b_long, i_y, i_access) - &
                   v_matrix(i_b_short, i_b_long, i_y, i_access)))

                  dev_matrix(i_b_short, i_b_long, i_y, i_access) = &
                   ABS(v_matrix_new(i_b_short, i_b_long, i_y, i_access) - v_matrix(i_b_short, i_b_long, i_y, i_access))

                  dev_matrix_q(i_b_short, i_b_long, i_y, i_access) = MIN(100d+0, &
                   ABS(q_paid_matrix_new(i_b_short, i_b_long, i_y, i_access)-q_paid_matrix(i_b_short, i_b_long, i_y, i_access)))

                  dev_q = MAX(dev_q, ABS(q_paid_matrix_new(i_b_short, i_b_long, i_y, i_access) - &
                   q_paid_matrix(i_b_short, i_b_long, i_y, i_access)))

                  dev_debt = MAX(dev_debt, ABS(b0_next_long_matrix_new(i_b_short, i_b_long, i_y, i_access) - &
                   b0_next_long_matrix(i_b_short, i_b_long, i_y, i_access)))

                  dev_res = MAX(dev_res, ABS(b0_next_short_matrix_new(i_b_short, i_b_long, i_y, i_access) - &
                   b0_next_short_matrix(i_b_short, i_b_long, i_y, i_access)))

                  IF(v0_matrix_new(i_b_short, i_b_long, i_y, i_access) < -20000d+0 .OR.  &
                       v1_matrix_new(i_b_short, i_b_long, i_y, i_access) < -20000d+0) THEN
                     write(*,*) 'Problem : Value Functions *very* negative'
                     ! write(*,*) 'iy ', i_y ,'ib ', i_b_long, 'ia ', i_b_short, 'ik', i_access
                     ! write(*,*) 'cons_1 ', cons_t_1_matrix(i_b_short, i_b_long, i_y, i_access),&
                     ! 'cons_0 ', cons_t_0_matrix(i_b_short, i_b_long, i_y, i_access)
                     ! write(*,*) 'a_next ', b_next_matrix(i_b_short, i_b_long,  i_y, i_access, 1),&
                     ! 'b_next ', b_next_matrix(i_b_short, i_b_long,  i_y, i_access, 2)
                     ! write(*,*) 'loan', loan_0_matrix(i_b_short, i_b_long, i_y_global, i_access),&
                     ! 'rate', rate_0_matrix(i_b_short, i_b_long, i_y_global, i_access)                  
                     ! pause
                  END IF
               END DO
            END DO
         END DO
      END DO


      WRITE(*, '(F6.2, X, F12.8, X, F12.8)') counter, deviation, dev_q

      dev_sofar = min(deviation, dev_sofar)

      OPEN(100, FILE ='iteration.txt',POSITION ='append')
      WRITE(100, '(F12.8, X, F12.8, X, F12.8, X, F12.8, X, F12.8)') deviation, dev_q, dev_res, dev_debt, counter
      CLOSE(100)
      !3) SAVE RESULTS OF THE CURRENT ITERATION

      OPEN (10, FILE='v.txt',STATUS='replace')
      OPEN (11, FILE='default.txt',STATUS='replace')
      OPEN (12, FILE='q.txt',STATUS='replace')
      OPEN (13, FILE='b_next.txt',STATUS='replace')
      OPEN (14, FILE='dev.txt',STATUS='replace')
      OPEN (16, FILE='q_paid.txt',STATUS='replace')
      OPEN (18, FILE='b_guess.txt',STATUS='replace')
      OPEN (19, FILE='c.txt',STATUS='replace')
      OPEN (20, FILE='output.txt',STATUS='replace')
      OPEN (21, FILE='labor.txt',STATUS='replace')
      OPEN (22, FILE='wage.txt',STATUS='replace')
      OPEN (23, FILE='counter.txt',STATUS='replace')
      OPEN (24, FILE='loan.txt',STATUS='replace')
      OPEN (25, FILE='rate.txt',STATUS='replace')
      OPEN (26, FILE='def_prob.txt',STATUS='replace')


      WRITE(23, '(F16.8)') counter

      DO i_access = 1,access_num
         DO i_y = 1,y_num
            DO i_b_long = 1,b_num_long
               DO i_b_short = 1,b_num_short

                i_y_global = i_y
                y_initial = y_grid(i_y)
                b_short_initial = b_grid_short(i_b_short)
                i_b_short_global = i_b_short

                b_long_initial = b_grid_long(i_b_long)
                i_b_long_global = i_b_long

                WRITE(10, '(F20.10, X, F20.10, X, F20.10)') v_matrix_new(i_b_short, i_b_long, i_y, i_access), &
                   v0_matrix_new(i_b_short, i_b_long, i_y, i_access), v1_matrix_new(i_b_short, i_b_long, i_y, i_access)

                WRITE(11, '(F6.2)') default_grid(default_decision(i_b_short, i_b_long, i_y, i_access))

                d = default_decision(i_b_short, i_b_long, i_y, i_access)
                g = y_grid(i_y)
                q_value  = q_fun(b_short_initial, b_long_initial, y_initial, i_access)

                WRITE(12, *) q_value

                WRITE(13, '(F15.11, X, F15.11)') b_next_matrix(i_b_short, i_b_long, i_y, i_access,1), &
                   b_next_matrix(i_b_short, i_b_long, i_y, i_access,2)

                WRITE(14, '(F15.11, X, F15.11)') dev_matrix(i_b_short, i_b_long, i_y, i_access), &
                   dev_matrix_q(i_b_short, i_b_long, i_y, i_access)

                WRITE(16, '(F15.8, X, F15.8, X, F15.8)') q_paid_matrix_new(i_b_short, i_b_long, i_y, i_access),&
                   q_nodef_matrix_new(i_b_short, i_b_long, i_y, i_access)

                WRITE(18, '(F15.8, X, F15.8, X, F15.8)') b0_next_short_matrix_new(i_b_short, i_b_long, i_y, i_access), &
                   b0_next_long_matrix_new(i_b_short, i_b_long, i_y, i_access), &
                   b1_next_short_matrix_new(i_b_short, i_b_long, i_y, i_access)

                WRITE(19, *) cons_t_0_matrix(i_b_short, i_b_long, i_y, i_access), &
                    cons_t_1_matrix(i_b_short, i_b_long, i_y, i_access)                   

                WRITE(20, *) output_t_0_matrix(i_b_short, i_b_long, i_y, i_access), &                   
                   output_t_1_matrix(i_b_short, i_b_long, i_y, i_access)                   

                WRITE(21, *) labor_0_matrix(i_b_short, i_b_long, i_y, i_access), &
                   labor_1_matrix(i_b_short, i_b_long, i_y, i_access)

                WRITE(22, *) wage_0_matrix(i_b_short, i_b_long, i_y, i_access), &
                   wage_1_matrix(i_b_short, i_b_long, i_y, i_access)

               WRITE(24, *) loan_0_matrix(i_b_short, i_b_long, i_y, i_access), &
                  loan_1_matrix(i_b_short, i_b_long, i_y, i_access)
               WRITE(25, *) rate_0_matrix(i_b_short, i_b_long, i_y, i_access), &
                  rate_1_matrix(i_b_short, i_b_long, i_y, i_access)   
                  
               WRITE(26, *) def_prob_tomorrow_interp_fun(b_short_initial, b_long_initial, y_initial, i_access)

                END DO
             END DO
          END DO
      END DO
      CLOSE(10)  
      CLOSE(11)
      CLOSE(12)
      CLOSE(13)
      CLOSE(14)
      CLOSE(16)
      CLOSE(18)
      CLOSE(19)
      CLOSE(20)
      CLOSE(21)
      CLOSE(22)
      CLOSE(23)
      CLOSE(24)
      CLOSE(25)
      CLOSE(26)

      WRITE(nout ,*) 'Iteration saved '
      v0_matrix  = v0_matrix_new
      v1_matrix  = v1_matrix_new
      v_matrix   = v_matrix_new
      q_paid_matrix = q_paid_matrix_new
      q_nodef_matrix = q_nodef_matrix_new
      b0_next_short_matrix = b0_next_short_matrix_new
      b0_next_long_matrix  = b0_next_long_matrix_new
      b1_next_short_matrix = b1_next_short_matrix_new

      if (deviation < criteria) then
         convergence =1

         open (1, FILE='graphs_exit_flag.txt', STATUS='replace')
         WRITE(1, *) 1
         close(1)
         
         ELSEIF (counter > 250) then
         convergence = 1
         open (1, FILE='graphs_exit_flag.txt', STATUS='replace')
         WRITE(1, *) 0
         close(1)
      end if

   END DO
END SUBROUTINE iterate

SUBROUTINE simulate
USE param
USE toolbox
implicit NONE
integer, allocatable :: seed(:)
integer :: n_seed
INTEGER :: period_num, i,j, sample_num, num_periodos, counter_immediate_def
PARAMETER (sample_num = 1000, period_num= 301, num_periodos = 120)
DOUBLE PRECISION :: random_matrix(period_num, sample_num, 3), random_vector(1:3*sample_num*period_num), &
z(period_num,sample_num), b_short(period_num+1,sample_num), b_long(period_num+1,sample_num),&
q(period_num,sample_num), eps, v_def, v_no_def, b_next(2), tb(period_num,sample_num),&
y_t_sim(period_num,sample_num), productivity_sim(period_num,sample_num),&
v_valor, q_risk_free,  q_short, b_next_short, &
cons_t_sim(period_num,sample_num), rate_sim(period_num,sample_num), &
labor_sim(period_num,sample_num), recovery_rate, wage_sim(period_num,sample_num), &
loan_sim(period_num,sample_num), output_total_sim(period_num,sample_num), &
def_prob_sim(period_num,sample_num),&
productivity, prod_loss
INTEGER :: liquidity(period_num, sample_num), excl(period_num, sample_num), d(period_num, sample_num), &
i_access_sim(period_num, sample_num)
DOUBLE PRECISION, EXTERNAL:: q_fun,objective_function, v0_fun, v1_fun, q_menu_fun, def_prob_tomorrow_interp_fun


! Initialize random seed and assign random numbers
call RANDOM_SEED(size = n_seed)
allocate(seed(n_seed))
seed=139719
call RANDOM_SEED(put=seed)
CALL RANDOM_NUMBER(random_vector)

!   ivalue=139719
!   CALL RNSET(ivalue)       !INITIALIZE THE SEED SO THE SAME RANDOM NUMBERS ARE GENERATED IN EVERY REALIZATION
!   CALL DRNUN(3*period_num*sample_num, random_vector)
  indicator_global_search = 1d+0
  counter = 1.0d+6
  q_risk_free = coupon* (1d+0 - ((1d+0 - delta)/(1d+0 + rw))**(counter-1d+0))/ (delta + rw)

  !First column of random_matrix is used to generate transitory shocks.
  !Second column of random_matrix is used to generate suddenstops.
  !Thirs column of random_matrix is used for re-access probability.
  DO j=1,sample_num
     DO i=1,period_num
        random_matrix(i,j,1)=random_vector((j-1)*period_num+i)
        random_matrix(i,j,2)=random_vector(period_num*sample_num + (j-1)*period_num+i)
        random_matrix(i,j,3)=random_vector(2*period_num*sample_num + (j-1)*period_num+i)
     END DO
  END DO


  OPEN (UNIT=21, FILE="data_sim.txt", status = 'replace')
  OPEN (UNIT=22, FILE="def_per.txt", status = 'replace')
  OPEN (UNIT=23, FILE="param.txt", status = 'replace')
  OPEN (UNIT=24, FILE="tirar.txt", status = 'replace')
  OPEN (UNIT=26, FILE="def_per_ss.txt", status = 'replace')

  WRITE(23, '(I10)') period_num-1
  WRITE(23, '(I10)') sample_num
  CLOSE(23)


  liquidity = 1  !ALWAYS ACCESS TO MARKETS
  i_access_initial = 1 !ALWAYS ACCESS TO MARKETS
  i_access_sim = i_access_initial

  counter_immediate_def = 0

  DO j=1,sample_num   !SOLVE FOR SAMPLE j
     WRITE(nout, *) j
     !Set initial values
     i = 1
     q_short = EXP(-rw)
     z(i,j) = mean_y

     b_short(i,j) = b_inf_short
     b_long(i,j) = b_inf
     d(i,j) = 1   !NO DEFAULT IN FIRST PERIOD
     i_default_global = 1
     excl(i,j) = 1 !NO EXCLUSION IN FIRST PERIOD
     b_short_initial = b_short(i,j)
     b_long_initial  = b_long(i,j)
     y_initial = z(i,j)

     CALL optimize(b_next, v_valor) !CHOOSE OPTIMAL B_S AND B_L ASSUMING NO DEFAULT
     b_short(i+1,j) = b_next(1)
     b_long(i+1,j) = b_next(2)
     q(i,j) = q_menu_fun(b_next(1), b_next(2), z(i,j), i_access_initial)
     productivity_sim(i,j) = EXP(z(i,j))
     y_t_sim(i,j) = output_t_global
     cons_t_sim(i,j) = cons_t_global
     labor_sim(i,j) = labor_global
     wage_sim(i,j) = wage_global
     rate_sim(i,j) = rate_global
     loan_sim(i,j) = loan_global
     tb(i,j) = y_t_sim(i,j) - cons_t_sim(i,j) - absortion_t
     def_prob_sim(i,j) = def_prob_tomorrow_interp_fun(b_next(1), b_next(2), z(i,j), i_access_initial)

     DO i=2,period_num
        recovery_rate = 0d+0
        !epsilon = realization of standard gaussian * standard deviation
        eps = normalCDF_Inv(random_matrix(i,j,1)) * std_eps
        z(i,j) = rho*z(i-1,j) + (1d+0-rho)*mean_y + eps   !current output = ex ante mean + epsilon
        y_initial = z(i,j)

        IF (random_matrix(i,j,2) <=trans_matrix(i_access_sim(i-1,j), 1) ) THEN  !TRANSIT TO STATE WITH LOW RISK PREMIUM
           i_access_sim(i,j) = 1
        ELSE !TRANSIT TO STATE WITH HIGH RISK PREMIUM
           i_access_sim(i,j) = 2
        END IF
        i_access_initial = i_access_sim(i,j)


        IF (excl(i-1,j) > 1) THEN !BORROWER WAS EXCLUDED IN THE PREVIOUS PERIOD
           v_no_def = v0_fun(b_short(i,j), b_recov, y_initial, i_access_initial)
           v_def    = v1_fun(b_short(i,j), b_recov, y_initial, i_access_initial)
           IF (random_matrix(i,j,3) <=prob_excl_end .AND. v_no_def>=v_def) THEN  !EXCLUSION ENDS and NO DEFAULT IS DECLARED

              excl(i,j) = 1
              d(i,j) = 1
              i_default_global = 1
              b_short_initial = b_short(i,j)
              b_long_initial = MIN(b_recov, b_long(i,j))
              recovery_rate = b_long_initial/ b_long(i,j)
              y_initial = z(i,j)
              CALL optimize(b_next, v_valor)
              b_short(i+1,j) = b_next(1)
              b_long(i+1,j) = b_next(2)
              q(i,j) = q_menu_fun(b_next(1), b_next(2), z(i,j), i_access_initial)
              productivity_sim(i,j) = EXP(z(i,j))
              y_t_sim(i,j) = output_t_global
              cons_t_sim(i,j) = cons_t_global              
              labor_sim(i,j) = labor_global
              wage_sim(i,j) = wage_global
              loan_sim(i,j) = loan_global
              rate_sim(i,j) = rate_global
              def_prob_sim(i,j) = def_prob_tomorrow_interp_fun(b_next(1), b_next(2), z(i,j), i_access_initial)
              tb(i,j) = y_t_sim(i,j) - cons_t_sim(i,j) - absortion_t

           ELSEIF (random_matrix(i,j,3) <=prob_excl_end .AND. v_no_def<v_def) THEN  !EXCLUSION ENDS and GOVERNMENT DEFAULTS AGAIN
              b_short_initial = b_short(i,j)
              b_long_initial = MIN(b_recov, b_long(i,j))
              d(i,j) = 1 ! HERE WE'RE TAKING THIS 'NEW' DEFAULT AS A CONTINUATION FROM THE PREVIOUS ONE.
              excl(i,j) = 2
              CALL optimize_excl(b_next_short, v_valor)
              b_short(i+1,j) = b_next_short
              b_long(i+1,j) = b_long_initial*EXP(rw)

              prod_loss = max(zero, exp(z(i,j))*(d0 + d1*(exp(z(i,j)) - one)))
              productivity = EXP(z(i,j)) - prod_loss
              productivity = max(zero, productivity) !Cannot let productivity be zero.
              productivity_sim(i,i) = escala * productivity

              y_t_sim(i,j) = output_t_global              
              cons_t_sim(i,j) = cons_t_global
              labor_sim(i,j) = labor_global
              wage_sim(i,j) = wage_global
              loan_sim(i,j) = loan_global
              rate_sim(i,j) = rate_global
              def_prob_sim(i,j) = def_prob_tomorrow_interp_fun(b_short(i+1,j), b_long(i+1,j), z(i,j), i_access_initial)
              tb(i,j) = y_t_sim(i,j) - cons_t_sim(i,j) - absortion_t

            !   q(i,j) = 1d+0 / (1d+0 + rw) !! Had this before. It's unused, but also wrong.
              q(i,j) = zero

              counter_immediate_def = counter_immediate_def + 1

           ELSE !exclusion continues
              b_short_initial = b_short(i,j)
              b_long_initial = MIN(b_recov, b_long(i,j))

              d(i,j) = 1
              excl(i,j) = 2

              CALL optimize_excl(b_next_short, v_valor)              
              b_short(i+1,j) = b_next_short
              b_long(i+1,j) = b_long_initial*EXP(rw)
              prod_loss = max(zero, exp(z(i,j))*(d0 + d1*(exp(z(i,j)) - one)))
              productivity = EXP(z(i,j)) - prod_loss
              productivity = max(zero, productivity) !Cannot let productivity be zero.
              productivity_sim(i,i) = escala * productivity
              y_t_sim(i,j) = output_t_global
              cons_t_sim(i,j) = cons_t_global
              labor_sim(i,j) = labor_global
              wage_sim(i,j) = wage_global
              loan_sim(i,j) = loan_global
              rate_sim(i,j) = rate_global
              def_prob_sim(i,j) = def_prob_tomorrow_interp_fun(b_short(i+1,j), b_long(i+1,j), z(i,j), i_access_initial)
              tb(i,j) = y_t_sim(i,j) - cons_t_sim(i,j) - absortion_t

            !   q(i,j) = 1d+0 / (1d+0 + rw) !! Had this before. It's unused, but also wrong.
              q(i,j) = zero

           END IF
        ELSEIF(excl(i-1,j) ==1) THEN

           b_short_initial = b_short(i,j)
           b_long_initial = b_long(i,j)

           v_no_def = v0_fun(b_short_initial, b_long_initial, y_initial, i_access_initial)
           v_def    = v1_fun(b_short_initial, b_long_initial, y_initial, i_access_initial)

           IF (v_def>v_no_def) THEN  !COUNTRY DEFAULTS
              d(i,j) = 2
              i_default_global = 2
              excl(i,j) = 2
              CALL optimize_excl(b_next_short, v_valor)
              
              b_short(i+1,j) = b_next_short
              b_long(i+1,j) = b_grid_long(1)*EXP(rw) !THE 1ST ELEMENT IN THE GRID, WHICH IS VERY CLOSE TO ZERO
              ! DOING THINGS THIS WAY ^, WILL MAKE THE SIMULATION EXACTLY CONSISTENT WITH THE SOLUTION
              ! b_long(i+1,j) = b_long_initial*EXP(rw) -- THIS IS WHAT WE HAD BEFORE
              prod_loss = max(zero, exp(z(i,j))*(d0 + d1*(exp(z(i,j)) - one)))
              productivity = EXP(z(i,j)) - prod_loss
              productivity = max(zero, productivity) !Cannot let productivity be zero.
              productivity_sim(i,i) = escala * productivity
              y_t_sim(i,j) = output_t_global
              cons_t_sim(i,j) = cons_t_global
              labor_sim(i,j) = labor_global
              wage_sim(i,j) = wage_global
              loan_sim(i,j) = loan_global
              rate_sim(i,j) = rate_global
              def_prob_sim(i,j) = def_prob_tomorrow_interp_fun(b_short(i+1,j), b_long(i+1,j), z(i,j), i_access_initial)
              tb(i,j) = y_t_sim(i,j) - cons_t_sim(i,j) - absortion_t

            !   q(i,j) = 1d+0 / (1d+0 + rw) !! Had this before. It's unused, but also wrong.
              q(i,j) = zero

              WRITE(22, '(I7)') i-1 !NEED TO SUBSTRACT 1. REASON: files start saving data on period 2

           ELSE
              d(i,j) = 1   !COUNTRY DOES NOT DEFAULT
              excl(i,j) = 1
              i_default_global = 1

              CALL optimize(b_next, v_valor)
              b_short(i+1,j) = b_next(1)
              b_long(i+1,j) = b_next(2)
              q(i,j) = q_menu_fun(b_next(1), b_next(2), z(i,j), i_access_initial)              
              productivity_sim(i,j)= EXP(z(i,j))
              y_t_sim(i,j) = output_t_global                                          
              cons_t_sim(i,j) = cons_t_global            
              labor_sim(i,j) = labor_global
              wage_sim(i,j) = wage_global
              loan_sim(i,j) = loan_global
              rate_sim(i,j) = rate_global
              def_prob_sim(i,j) = def_prob_tomorrow_interp_fun(b_next(1), b_next(2), z(i,j), i_access_initial)
              tb(i,j) = y_t_sim(i,j) - cons_t_sim(i,j) - absortion_t
           END IF

        END IF

        
        WRITE(21, *) y_t_sim(i,j), productivity_sim(i,j), b_short(i,j), b_long(i,j),  q(i,j), &
        cons_t_sim(i,j), rate_sim(i,j),tb(i,j)/y_t_sim(i,j), d(i,j), excl(i,j),&
        i_access_sim(i,j), z(i,j), wage_sim(i,j), labor_sim(i,j), loan_sim(i,j),&
        def_prob_sim(i,j)

     END DO
  END DO
  CLOSE(21)
  CLOSE(22)
  CLOSE(24)
  CLOSE(26)

WRITE(6,*) 'counter_immediate_def', counter_immediate_def

END SUBROUTINE simulate


PROGRAM main
  USE param
  USE toolbox
  IMPLICIT NONE
  INTEGER  i_b_short, i_b_long, i_y, i_access
  DOUBLE PRECISION :: start_time, end_time, indicator_external, b_long,dur_excl,cons_t, &
  labor, wage, output_t, util, productivity, loan, r_repay_local, prod_loss
  DOUBLE PRECISION, DIMENSION(b_num_short, b_num_long,  y_num, 2) :: output_t_0_matrix, output_t_1_matrix,&
  cons_t_0_matrix, cons_t_1_matrix, labor_0_matrix, labor_1_matrix, wage_0_matrix, wage_1_matrix, productivity_loss_matrix
  double precision, external :: u_fun
  
  OPEN (1987, FILE='param_sigma.txt')
  READ(1987, *) sigma
  CLOSE(1987)
  sigma = sigma/100d+0

  OPEN (1987, FILE='param_beta.txt')
  READ(1987, *) beta
  CLOSE(1987)

  OPEN (1987, FILE='param_d0.txt')
  READ(1987, *) d0
  CLOSE(1987)
  d0 = d0/1000d+0

  OPEN (1987, FILE='param_d1.txt')
  READ(1987, *) d1
  CLOSE(1987)
  d1 = d1/100d+0 
  
  OPEN (1987, FILE='param_dur_excl.txt')
  READ(1987, *) dur_excl
  CLOSE(1987)

  OPEN (1987, FILE='param_delta.txt')
  READ(1987, *) delta
  CLOSE(1987)

  OPEN (1987, FILE='param_risk_premium.txt')
  READ(1987, *) premia_grid(2)
  CLOSE(1987)
  premia_grid(2) = premia_grid(2)/10d+0

  OPEN (1987, FILE='param_output_cost.txt')
  READ(1987, *) output_cost
  CLOSE(1987)

  OPEN (1987, FILE='param_w_bar.txt')
  READ(1987, *) w_bar
  CLOSE(1987)
  w_bar = w_bar/100d+0

  OPEN (1987, FILE='param_gasto.txt')
  READ(1987, *) absortion_t
  CLOSE(1987)
  absortion_t = absortion_t/100d+0
   
  OPEN (1987, FILE='param_phi.txt')
  READ(1987, *) phi
  CLOSE(1987)
  phi = phi/100d+0

  OPEN (1987, FILE='param_mu.txt')
  READ(1987, *) mu
  CLOSE(1987)

  OPEN (1987, FILE='param_omega.txt')
  READ(1987, *) omega
  CLOSE(1987)

  OPEN (1987, FILE='param_r_default.txt')
  READ(1987, *) r_default
  CLOSE(1987)
  r_default = r_default/100d+0

  OPEN (1987, FILE='param_r_premium.txt')
  READ(1987, *) r_premium
  CLOSE(1987)
  r_premium = r_premium/100d+0
  r_premium = rw

  OPEN (1987, FILE='param_phi_firm.txt')
  READ(1987, *) phi_firm
  CLOSE(1987)
  phi_firm = phi_firm/100d+0

  OPEN (1987, FILE='param_curvature_labor.txt')
  READ(1987, *) curvature_labor
  CLOSE(1987)

  OPEN (1987, FILE='param_alpha_dp.txt')
   READ(1987, *) alpha_dp
   CLOSE(1987)
   alpha_dp = alpha_dp/100d+0

!   mu = sigma - 1d+0 ! this ensures that intertemporal elasticity of substitution is equal to the intra-temporal elast. of subst (btw T and NT)
  
  b_recov = 0d+0 !zero recovery
  prob_excl_end = 1d+0/ dur_excl

  trans_matrix(2,2) = 0.2d+0 !PROBABILITY OF REMAINING IN HIGH PREMIA STATE
  trans_matrix(2,1) = 1d+0 - trans_matrix(2,2)  !PROBABILITY OF SWITCHING FORM HIGH PREMIA to LOW PREMIA
  trans_matrix(1,1) = 0.85d+0 !    !PROBABILITY OF REMAINING IN LOW PREMIA STATE
  trans_matrix(1,2) = 1d+0 - trans_matrix(1,1)    !PROBABILITY OF SWITCHING FORM LOW PREMIA to HIGH PREMIA

  premia_grid(1) = 0d+0

  WRITE(6, *) 'sigma         ', sigma
  WRITE(6, *) 'beta          ', beta
  WRITE(6, *) 'd0            ', d0
  WRITE(6, *) 'd1            ', d1
  WRITE(6, *) 'prob_excl_end ', prob_excl_end
  WRITE(6, *) 'delta         ', delta
  WRITE(6, *) 'premia_grid   ', premia_grid(2)
  WRITE(6, *) 'output_cost   ', output_cost
  WRITE(6, *) 'w_bar         ', w_bar
  WRITE(6, *) 'mu            ', mu
  WRITE(6, *) 'omega         ', omega
  WRITE(6, *) 'phi_firm      ', phi_firm
  WRITE(6, *) 'r_default     ', r_default
  WRITE(6, *) 'curvature_labor ', curvature_labor

  CALL CPU_TIME(start_time)
  CALL compute_grid
  CALL quadrature
  
  indicator_external = 0d+0 !FROM EXTERNAL FILE  
  
  IF (indicator_external < 0.5d+0) THEN
   counter = 0

   OPEN (101, FILE='v_lp.txt',STATUS='replace')
   OPEN (102, FILE='default_lp.txt',STATUS='replace')
   OPEN (103, FILE='c_lp.txt',STATUS='replace')
   OPEN (104, FILE='output_lp.txt',STATUS='replace')
   OPEN (105, FILE='labor_lp.txt',STATUS='replace')
   OPEN (106, FILE='wage_lp.txt',STATUS='replace')
   OPEN (107, FILE='productivity_loss_lp.txt',STATUS='replace')
   
   DO i_access = 1,access_num
      i_access_initial = i_access
      DO i_y = 1,y_num
         y_initial = y_grid(i_y)
         DO i_b_short = 1,b_num_short
            b_short_initial = b_grid_short(i_b_short)
            
            b_long = b_inf
            i_default_global = 2
            prod_loss = max(zero, exp(y_initial)*(d0 + d1*(exp(y_initial) - one)))
            productivity = EXP(y_initial) - prod_loss
            productivity = max(zero, productivity) !Cannot let productivity be zero.
            productivity = escala * productivity
            
            labor = ((alpha * productivity)/(1d+0 + gamma * r_default) * one/scale_labor)**(one/(curvature_labor-alpha)) 
            wage = scale_labor * labor**(curvature_labor-one)
            loan = gamma * wage * labor
            output_t = productivity * labor**(alpha)
            cons_t = output_t + b_short_initial - absortion_t - loan * r_default
            ! cons_t = max(cons_t,1d-6)
            util = u_fun(cons_t, labor)

            v1_matrix(i_b_short, :, i_y, i_access) = util
            output_t_1_matrix(i_b_short, :, i_y, i_access) = output_t            
            cons_t_1_matrix(i_b_short, :, i_y, i_access) = cons_t            
            labor_1_matrix(i_b_short, :, i_y, i_access) = labor
            wage_1_matrix(i_b_short, :, i_y, i_access) = wage
            productivity_loss_matrix(i_b_short, :, i_y, i_access) = prod_loss

              DO i_b_long = 1,b_num_long
               i_default_global = 1
               b_long_initial = b_grid_long(i_b_long)

               productivity = escala * EXP(y_initial)
               ! r_repay_local = r_premium + phi_firm *  (one - productivity)
               r_repay_local = r_premium + phi_firm *  (escala - productivity)/escala

               labor = ((alpha * productivity)/(1d+0 + gamma * r_repay_local) * one/scale_labor)**(one/(curvature_labor-alpha))
               wage = scale_labor * labor**(curvature_labor-one)
               loan = gamma * wage * labor
               output_t = productivity * labor**(alpha)
               ! cons_t = output_t + b_short_initial - absortion_t - loan * r_repay_local - &
                  ! coupon*(1d+0 + phi *(productivity-one))* b_long_initial
               cons_t = output_t + b_short_initial - absortion_t - loan * r_repay_local - &
               coupon*(1d+0 + phi *(productivity-escala)/escala)* b_long_initial
               ! cons_t = max(cons_t,1d-6)
               util = u_fun(cons_t, labor)

               v0_matrix(i_b_short, i_b_long, i_y, i_access) = util
               output_t_0_matrix(i_b_short, i_b_long, i_y, i_access) = output_t
               ! output_nt_0_matrix(i_b_short,i_b_long, i_y, i_access) = output_nt
               cons_t_0_matrix(i_b_short, i_b_long, i_y, i_access) = cons_t
               ! cons_nt_0_matrix(i_b_short,i_b_long, i_y, i_access) = cons_nt
               labor_0_matrix(i_b_short,i_b_long, i_y, i_access) = labor
               wage_0_matrix(i_b_short,i_b_long, i_y, i_access) = wage               

               v_matrix(i_b_short, i_b_long, i_y, i_access) = MAX(v1_matrix(i_b_short, i_b_long,i_y, i_access), &
               v0_matrix(i_b_short, i_b_long, i_y, i_access))
               
               IF (v1_matrix(i_b_short, i_b_long,i_y, i_access) > v0_matrix(i_b_short, i_b_long, i_y, i_access)) THEN
                  default_decision(i_b_short, i_b_long, i_y, i_access) = 2
               ELSE
                  default_decision(i_b_short, i_b_long, i_y, i_access) = 1
               END IF
            END DO
         END DO
      END DO
   END DO
   
   DO i_access = 1,access_num
      DO i_y = 1,y_num
         DO i_b_long = 1,b_num_long
            DO i_b_short = 1,b_num_short
               WRITE(101,*) v_matrix(i_b_short, i_b_long, i_y, i_access), v0_matrix(i_b_short, i_b_long, i_y, i_access),&
               v1_matrix(i_b_short, i_b_long, i_y, i_access)
               
               WRITE(102,*) default_grid(default_decision(i_b_short, i_b_long, i_y, i_access))
               
               WRITE(103,*) cons_t_0_matrix(i_b_short, i_b_long, i_y, i_access),&
               cons_t_1_matrix(i_b_short, i_b_long, i_y, i_access)
               ! cons_nt_0_matrix(i_b_short, i_b_long, i_y, i_access),&               
               ! cons_nt_1_matrix(i_b_short, i_b_long, i_y, i_access)
               
               WRITE(104,*) output_t_0_matrix(i_b_short, i_b_long, i_y, i_access),&
               output_t_1_matrix(i_b_short, i_b_long, i_y, i_access)
               ! output_nt_0_matrix(i_b_short, i_b_long, i_y, i_access),&               
               ! output_nt_1_matrix(i_b_short, i_b_long, i_y, i_access)
               
               WRITE(105,*) labor_0_matrix(i_b_short, i_b_long, i_y, i_access), &
               labor_1_matrix(i_b_short, i_b_long, i_y, i_access)
               
               WRITE(106,*) wage_0_matrix(i_b_short, i_b_long, i_y, i_access), &
               wage_1_matrix(i_b_short, i_b_long, i_y, i_access)

               WRITE(107,*) productivity_loss_matrix(i_b_short, i_b_long, i_y, i_access)   

            END DO
         END DO
      END DO
   END DO

   CLOSE(101)
   CLOSE(102)
   CLOSE(103)
   CLOSE(104)
   CLOSE(105)
   CLOSE(106)
   CLOSE(107)

   q_paid_matrix = zero
   q_nodef_matrix = zero

   b0_next_short_matrix = zero
   b0_next_long_matrix = zero
   ELSE !READ DATA FROM EXTERNAL FILES

   OPEN (10, FILE='v.txt')
   OPEN (16, FILE='q_paid.txt')
   OPEN (18, FILE='b_guess.txt')
   OPEN (19, FILE='counter.txt')

   READ (19, '(F16.8)') counter
   DO i_access = 1,access_num
      DO i_y = 1,y_num
         DO i_b_long = 1,b_num_long
            DO i_b_short = 1,b_num_short
               READ(10, '(F20.10, X, F20.10, X, F20.10)') v_matrix(i_b_short, i_b_long, i_y, i_access), &
               v0_matrix(i_b_short, i_b_long, i_y, i_access), v1_matrix(i_b_short, i_b_long, i_y, i_access)
               IF (v0_matrix(i_b_short, i_b_long, i_y, i_access)< v1_matrix(i_b_short, i_b_long, i_y, i_access)) THEN
                  default_decision(i_b_short, i_b_long, i_y, i_access) =2
               ELSE
                  default_decision(i_b_short, i_b_long, i_y, i_access) =1
               END IF
               
               READ(16, '(F15.8, X, F15.8, X, F15.8)')  q_paid_matrix(i_b_short, i_b_long, i_y, i_access), &
               q_nodef_matrix(i_b_short, i_b_long, i_y, i_access)
               
               READ(18, '(F15.8, X, F15.8, X, F15.8)') b0_next_short_matrix(i_b_short, i_b_long, i_y, i_access), &
               b0_next_long_matrix(i_b_short, i_b_long, i_y, i_access), &
               b1_next_short_matrix(i_b_short, i_b_long, i_y, i_access)
            END DO
         END DO
      END DO
   END DO
   CLOSE(10)
   CLOSE(16)
   CLOSE(18)
   CLOSE(19)

END IF

CALL iterate
CALL simulate

CALL CPU_TIME(end_time)
WRITE(nout, '(A7, X, A7, X, A7)') 'Hours ', 'Minutes', 'Seconds'
WRITE(nout, '(I7, X, I7, X, I7)') INT((end_time - start_time) / 3600d+0), &
INT((end_time-start_time)/60d+0 - INT((end_time - start_time) / 3600d+0)*60d+0),&
INT(end_time-start_time - INT((end_time - start_time) / 3600d+0)*3600d+0 - &
INT((end_time-start_time)/60d+0 - INT((end_time - start_time) / 3600d+0)*60d+0)*60d+0)

END PROGRAM main

! EXTERNAL ROUTINE -- nothing modified from here on:
SUBROUTINE POWELL(FUNC,P,XI,N,NP,FTOL,ITER,FRET)
!-----------------------------------------------------------
! Minimization of a function  FUNC of N variables  (FUNC is
! not an argument, it is a fixed function name). Input con-
! sists of an initial starting point P  that is a vector of
! length N; an initial matrix XI  whose  logical dimensions
! are N by N, physical dimensions NP by NP, and whose columns26
! contain the initial set of directions (usually the N unit
! vectors); and FTOL, the fractional tolerance in the func-
! tion value such that failure to decrease by more than this
! amount on one iteration signals doneness. On output, P is
! set to the best point found, XI is the then-current direc-
! tion set,  FRET is the returned function value at P,  and
! ITER is the number of iterations taken. The routine LINMIN
! is used.
!------------------------------------------------------------
  !IMPLICIT DOUBLE PRECISION  (A-H,O-Z)
  INTEGER :: N, NP, NMAX, ITMAX, I, IBIG, J, ITER
  PARAMETER(NMAX=2,ITMAX=100)
  DOUBLE PRECISION :: P(NP),XI(NP,NP),PT(NMAX),PTT(NMAX),XIT(NMAX)
  DOUBLE PRECISION :: FRET, FP, DEL, FPTT, FTOL, T
  !EXTERNAL objective_function_nobind

  interface
  DOUBLE PRECISION PURE FUNCTION FUNC(ARG)
    DOUBLE PRECISION, intent(in) :: ARG(2)
  end function
  end interface

  FRET=  FUNC(P) !objective_function_nobind(P) !
  !write(nout, *) FRET, objective_function_nobind(P)
  !pause

  DO J=1,N
    PT(J)=P(J)       !Save initial pont
  END DO
  ITER=0
1 ITER=ITER+1
  FP=FRET
  IBIG=0
  DEL=0.0D+0           !Will be the biggest function decrease.
  DO I=1,N           !In each iteration, loop over all directions in the set.
    DO J=1,N         !Copy the direction
      XIT(J)=XI(J,I)
    END DO
    FPTT=FRET
    CALL LINMIN(FUNC,P,XIT,N,FRET)  !Minimize along it.
    IF (DABS(FPTT-FRET).GT.DEL) THEN
      DEL=DABS(FPTT-FRET)
      IBIG=I
    END IF
  END DO
  IF (2.D0*DABS(FP-FRET).LE.FTOL*(DABS(FP)+DABS(FRET))) RETURN !Termination criterion
  IF (ITER.EQ.ITMAX) Then
    Pause ' Powell exceeding maximum iterations.'
    return
  END IF
  DO J=1,N
    PTT(J)=2.D0*P(J)-PT(J)  !Construct the extrapolated point and the average
    XIT(J)=P(J)-PT(J)       !direction moved. Save the old starting point.
    PT(J)=P(J)
  END DO
  FPTT= FUNC(PTT) ! objective_function_nobind(PTT) !          !Function value at extrapolated point.
!  write(nout, '(F12.8, X, F12.8, X, F15.6, X, F15.6)') PTT(1), PTT(2), FPTT, objective_function_nobind(PTT)
  IF (FPTT.GE.FP) GO TO 1   !One reason not to use new direction.
  T=2.D0*(FP-2.D0*FRET+FPTT)*(FP-FRET-DEL)**2D+0-DEL*(FP-FPTT)**2D+0
  IF (T.GE.0.D0) GO TO 1    !Other reason not to use new direction.
  CALL LINMIN(FUNC,P,XIT,N,FRET) !Move to the minimum of the new direction.
  DO J=1,N                  !and save the new direction
    XI(J,IBIG)=XIT(J)
  END DO
  GO TO 1
END

SUBROUTINE LINMIN(FUNC,P,XI,N,FRET)
!----------------------------------------------------------
! Given an N dimensional point P and a N dimensional direc-
! tion XI, moves and resets P to where the function FUNC(P)
! takes on a minimum along the direction XI from P, and
! replaces XI by the actual vector displacement that P was
! moved. Also returns as FRET the value of FUNC at the
! returned location P. This is actually all accomplished by
! calling the routines MNBRAK and BRENT.
!----------------------------------------------------------
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  DOUBLE PRECISION :: TOL
  INTEGER :: N, NMAX, NCOM, J
  PARAMETER(NMAX=50,TOL=1.D-4)
  DOUBLE PRECISION :: P(N),XI(N) !, PCOM(N), XICOM(N)
  DOUBLE PRECISION :: AX, XX, BX, FA, FX,FB, FRET, BRENT
  COMMON /F1COM/ PCOM(NMAX),XICOM(NMAX),NCOM

  interface
  DOUBLE PRECISION PURE FUNCTION FUNC(ARG)
    DOUBLE PRECISION, intent(in) :: ARG(2)
  end function
  end interface
  NCOM=N
  DO J=1,N
    PCOM(J)=P(J)
    XICOM(J)=XI(J)
  END DO
  AX=0.D0
  XX=1.D0
  BX=2.D0
  CALL MNBRAK(FUNC,AX,XX,BX,FA,FX,FB)
  FRET=BRENT(FUNC,AX,XX,BX,TOL,XMIN)
  DO J=1,N
    XI(J)=XMIN*XI(J)
    P(J)=P(J)+XI(J)
  END DO
  RETURN
END

DOUBLE PRECISION FUNCTION F1DIM(FUNC,X)
  IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  INTEGER :: NMAX, J, NCOM
  PARAMETER(NMAX=50)
  COMMON /F1COM/ PCOM(NMAX),XICOM(NMAX),NCOM
  DOUBLE PRECISION :: XT(NMAX), X
  !EXTERNAL objective_function_nobind
 ! EXTERNAL FUNC

  interface
  DOUBLE PRECISION PURE FUNCTION FUNC(ARG)
    DOUBLE PRECISION, intent(in) :: ARG(2)
  end function
  end interface

  DO J=1, NCOM
    XT(J)=PCOM(J)+X*XICOM(J)
  END DO
  F1DIM = FUNC(XT) !objective_function_nobind(XT) !
  RETURN
END

SUBROUTINE MNBRAK(FUNC,AX,BX,CX,FA,FB,FC)
!----------------------------------------------------------------------
!Given a Function F1DIM(X), and given distinct initial points AX and
!BX, this routine searches in the downhill direction (defined by the
!F1DIMtion as evaluated at the initial points) and returns new points
!AX, BX, CX which bracket a minimum of the Function. Also returned
!are the Function values at the three points, FA, FB and FC.
IMPLICIT DOUBLE PRECISION (A-H,O-Z)
DOUBLE PRECISION :: GOLD, GLIMIT, TINY, FA, FB,FC, AX,BX,CX, DUM,R,Q,U,ULIM,FU, F1DIM
PARAMETER(GOLD=1.618034,GLIMIT=100.,TINY=1.D-20)
  interface
  DOUBLE PRECISION PURE FUNCTION FUNC(ARG)
    DOUBLE PRECISION, intent(in) :: ARG(2)
  end function
  end interface

!The first parameter is the default ratio by which successive intervals
!are magnified; the second is the maximum magnification allowed for
!a parabolic-fit step.
!----------------------------------------------------------------------
FA=F1DIM(FUNC,AX)
FB=F1DIM(FUNC,BX)
IF(FB.GT.FA) THEN
  DUM=AX
  AX=BX
  BX=DUM
  DUM=FB
  FB=FA
  FA=DUM
ENDIF
CX=BX+GOLD*(BX-AX)
FC=F1DIM(FUNC,CX)
1 IF(FB.GE.FC) THEN
  R=(BX-AX)*(FB-FC)
  Q=(BX-CX)*(FB-FA)
  U=BX-((BX-CX)*Q-(BX-AX)*R)/(2.*SIGN(MAX(ABS(Q-R),TINY),Q-R))
  ULIM=BX+GLIMIT*(CX-BX)
  IF((BX-U)*(U-CX).GT.0) THEN
    FU=F1DIM(FUNC,U)
    IF(FU.LT.FC) THEN
      AX=BX
      FA=FB
      BX=U
      FB=FU
      GOTO 1
    ELSE IF(FU.GT.FB) THEN
      CX=U
      FC=FU
      GOTO 1
    ENDIF
    U=CX+GOLD*(CX-BX)
    FU=F1DIM(FUNC,U)
  ELSE IF((CX-U)*(U-ULIM).GT.0) THEN
    FU=F1DIM(FUNC,U)
    IF(FU.LT.FC) THEN
      BX=CX
      CX=U
      U=CX+GOLD*(CX-BX)
      FB=FC
      FC=FU
      FU=F1DIM(FUNC,U)
    ENDIF
  ELSE IF((U-ULIM)*(ULIM-CX).GE.0) THEN
    U=ULIM
    FU=F1DIM(FUNC,U)
  ELSE
    U=CX+GOLD*(CX-BX)
    FU=F1DIM(FUNC,U)
  ENDIF
  AX=BX
  BX=CX
  CX=U
  FA=FB
  FB=FC
  FC=FU
  GOTO 1
ENDIF
RETURN
END

DOUBLE PRECISION FUNCTION BRENT(FUNC,AX,BX,CX,TOL,XMIN)
!-------------------------------------------------------------------
!Given a function F1DIM, and a bracketing triplet of abscissas
!AX,BX,CX (such that BX is between AX and CX, and F(BX) is less
!than both F(AX) and F(CX)), this routine isolates the minimum
!to a fractional precision of about TOL using Brent's method.
!The abscissa of the minimum is returned in XMIN, and the minimum
!function value is returned as BRENT, the returned function value.
!-------------------------------------------------------------------
IMPLICIT DOUBLE PRECISION (A-H,O-Z)
INTEGER :: ITMAX,ITER
DOUBLE PRECISION :: CGOLD, ZEPS
PARAMETER(ITMAX=100,CGOLD=.3819660,ZEPS=1.D-10)
!Maximum allowed number of iterations; golden ration; and a small
!number which protects against trying to achieve fractional accuracy
!for a minimum that happens to be exactly zero.
DOUBLE PRECISION :: AX,BX, CX,TOL,XMIN,A,B,V,W,X,E,FX,FV,FU,FW,XM,TOL1,TOL2,R,P,Q,ETEMP,D,U
interface
  DOUBLE PRECISION PURE FUNCTION FUNC(ARG)
    DOUBLE PRECISION, intent(in) :: ARG(2)
  end function
  end interface


A=MIN(AX,CX)
B=MAX(AX,CX)
V=BX
W=V
X=V
E=0.
FX=F1DIM(FUNC,X)
FV=FX
FW=FX
DO 11 ITER=1,ITMAX   !main loop
  XM=0.5*(A+B)
  TOL1=TOL*ABS(X)+ZEPS
  TOL2=2.*TOL1
  IF (ABS(X-XM).LE.(TOL2-.5*(B-A))) GOTO 3  !Test for done here
  IF (ABS(E).GT.TOL1) THEN     !Construct a trial parabolic fit
    R=(X-W)*(FX-FV)
    Q=(X-V)*(FX-FW)
    P=(X-V)*Q-(X-W)*R
    Q=.2*(Q-R)
    IF (Q.GT.0)  P=-P
    Q=ABS(Q)
    ETEMP=E
    E=D
    IF (ABS(P).GE.ABS(.5*Q*ETEMP).OR.P.LE.Q*(A-X).OR.  &
    P.GE.Q*(B-X))  GOTO 1
!   The above conditions determine the acceptability of the
!   parabolic fit. Here it is o.k.:
    D=P/Q
    U=X+D
    IF (U-A.LT.TOL2.OR.B-U.LT.TOL2)  D=SIGN(TOL1,XM-X)
    GOTO 2
  ENDIF
1 IF (X.GE.XM) THEN
    E=A-X
  ELSE
    E=B-X
  ENDIF
  D=CGOLD*E
2 IF (ABS(D).GE.TOL1) THEN
    U=X+D
  ELSE
    U=X+SIGN(TOL1,D)
  ENDIF
  FU=F1DIM(FUNC,U)  !This the one function evaluation per iteration
  IF (FU.LE.FX) THEN
    IF (U.GE.X) THEN
      A=X
    ELSE
      B=X
    ENDIF
    V=W
    FV=FW
    W=X
    FW=FX
    X=U
    FX=FU
  ELSE
    IF (U.LT.X) THEN
      A=U
    ELSE
      B=U
    ENDIF
    IF (FU.LE.FW.OR.W.EQ.X) THEN
      V=W
      FV=FW
      W=U
      FW=FU
    ELSE IF (FU.LE.FV.OR.V.EQ.X.OR.V.EQ.W) THEN
      V=U
      FV=FU
    ENDIF
  ENDIF
11 CONTINUE
!Pause ' Brent exceed maximum iterations.'
3 XMIN=X   !exit section
  BRENT=FX
  RETURN
  END
!end of file tpowell.f90

subroutine BISEC(func, x1, x2, ERRABS, ERRREL)
implicit none
DOUBLE PRECISION, INTENT(IN) ::  ERRABS, ERRREL
DOUBLE PRECISION, INTENT(IN OUT) :: x2, x1
DOUBLE PRECISION :: diff
INTEGER :: nout

interface
        function func(x)
        implicit none
        DOUBLE PRECISION, INTENT(IN) :: x
        DOUBLE PRECISION :: func
        end function func
END interface
DOUBLE PRECISION :: fl, fh, f_mean, xl, xh, xmean, rel_error

xl=x1
xh=x2
fl=func(xl)
fh=func(xh)
diff = fh-fl
rel_error=1

do WHILE( MIN((ABS(fh)-ERRABS), rel_error-ERRREL) > 0)

xmean =  0.5d+0 * (xl+xh)
!xl - fl / ((fh - fl)/(xh-xl) )  !Use linear approx to find the zero !(xl+xh)/2
f_mean = func(xmean)

if (fl*fh>0) then
   !WRITE(nout,*) 'Wrong range'       !Need change of signs to compute the root
   !call BREAK
else
   if (diff < 0) then
      if (f_mean > 0) then
         xl=xmean
         fl=f_mean
      else
         xh=xmean
         fh=f_mean
      end if
   else
      if (f_mean > 0) then
         xh=xmean
         fh=f_mean
      else
         xl=xmean
         fl=f_mean
      end if
    end if

end if
rel_error=ABS(xh-xl)

!WRITE(6,*) rel_error, fh
end do
x1 = xl
x2 = xh

end subroutine BISEC
